package mpi.eudico.client.annotator.lexica;

import java.awt.Component;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.table.TableCellRenderer;

import mpi.eudico.client.annotator.Constants;

import org.jdom.Element;

public class ChooseReferenceTableRenderer implements TableCellRenderer{
	private JTextField component;
	
	public ChooseReferenceTableRenderer(){
		component=new JTextField();
	}
	
	@Override
	public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
		component.setOpaque(true);
		component.setEnabled(true);
		
		boolean isActive=false;
		if(table.getSelectedColumn()==column &&row==table.getSelectedRow()&&table.getValueAt(row, column)!=null){
			isActive=true;
		}

		setComponentLayout(component, table, isSelected, isActive);
        setAlignment(component, table.getColumnName(column));
		if(value instanceof LexiconTableContent){
			LexiconTableContent lexContent=((LexiconTableContent) value);
			Element lexemeElmt=lexContent.getLexemeElmt();
			Element lexicalEntry=lexemeElmt.getParentElement();
			Element senseElmt=lexicalEntry.getChild(LexiconDocumentData.SENSE);
			List<Element> gloseElmtList=senseElmt.getChildren(LexiconDocumentData.GLOSE);
			
			if(column==ChooseReferenceTableModel.ID){
				component.setText(lexContent.getAssociatedLexicalEntryId()); 
			} else if(column==ChooseReferenceTableModel.LX){
				component.setText(lexemeElmt.getText());
			} else if(column==ChooseReferenceTableModel.A){
				String variant="";
				List<LexiconVariantContent> variantContentList=lexContent.getLexiconVariantList();
				for(int i=0; i<variantContentList.size(); i++){
					LexiconVariantContent variantContent=variantContentList.get(i);
					variant+=variantContent.getVariant();
					if(i<variantContentList.size()-1){
						variant+="; ";
					}
				}
				component.setText(variant);
			} else if(column==ChooseReferenceTableModel.GE){
				String gloses="";
				for(int i=0; i<gloseElmtList.size(); i++){
					Element gloseElmt=gloseElmtList.get(i);
					gloses+=gloseElmt.getText();
					int iNext=i+1;
					if(iNext<gloseElmtList.size()){
						gloses+=";";
					}
				}
				component.setText(gloses);
			} else if(column==ChooseReferenceTableModel.RX){
				String tierXs="";
				for(int i=0; i<gloseElmtList.size(); i++){
					Element gloseElmt=gloseElmtList.get(i);
					tierXs+=gloseElmt.getAttributeValue(LexiconDocumentData.RX);
					int iNext=i+1;
					if(iNext<gloseElmtList.size()){
						tierXs+=";";
					}
				}
				component.setText(tierXs);
			}
			return component;
		}
		return null;
	}
	
	protected static void setComponentLayout(JComponent component,JTable table, boolean isSelected, boolean isActive) {
		component.setFont(table.getFont());
		component.setBorder(BorderFactory.createEmptyBorder(0,1, 0, 3));
		component.setBackground(isSelected ? Constants.SELECTIONCOLOR: table.getBackground());
		//component.setBorder(isActive ? new LineBorder(Constants.ACTIVEANNOTATIONCOLOR): table.getBorder());
	}
	
	protected static void setAlignment(JComponent component, String columnName) {
		component.setAlignmentX(SwingConstants.CENTER);
	}
	  

}
