package mpi.eudico.client.annotator.lexica;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JTextField;

import mpi.eudico.client.annotator.gui.ClosableDialog;
import mpi.eudico.client.annotator.lexica.record.JDomElementListCellRenderer;
import mpi.eudico.client.annotator.lexica.record.SegmentToDefineSubPane;

public class LXParsingReferenceDialog extends ClosableDialog implements ActionListener{
	private SegmentToDefine segmentToDefine;
	
	private JLabel morphemeLb;
	private JTextField morphemeTxtField;
	private JButton okButton;
	private List<SegmentToDefineSubPane> segmentSubPaneList;
	
	public LXParsingReferenceDialog(SegmentToDefine segmentToDefine){
		this.setVisible(true);
		setTitle("Parsing reference");
		this.segmentToDefine=segmentToDefine;
		initComponents();
	}
	
	private void initComponents() {
		segmentSubPaneList=new ArrayList<SegmentToDefineSubPane>();
		morphemeLb=new JLabel("Morpheme to parse :");
		morphemeTxtField=new JTextField(segmentToDefine.getMorphemeToParse());
		morphemeTxtField.setEditable(false);
		
		this.setLayout(new GridBagLayout());

        GridBagConstraints gbc = new GridBagConstraints();
        Insets insets = new Insets(2, 2, 2, 2);
        gbc = new GridBagConstraints();
        gbc.gridx=0;
        gbc.gridy=0;
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.insets = insets;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.weighty = 1.0;
        this.add(morphemeLb, gbc);
        gbc.gridx=1;
        gbc.gridy=0;
        this.add(morphemeTxtField, gbc);
        int i=0;
        while(i<segmentToDefine.getSegmentElementsListSize()){
        	gbc.gridx=0;
        	gbc.gridy=1+i;
        	SegmentToDefineSubPane segmentPane=new SegmentToDefineSubPane(segmentToDefine.getSegmentForm(i), segmentToDefine.getReferencePossibilities(i));
        	segmentSubPaneList.add(segmentPane);
        	this.add(segmentPane, gbc);
        	i++;
        }
        gbc.gridx=0;
        gbc.gridy=i+1;
        okButton=new JButton("OK");
        okButton.addActionListener(this);
        this.add(okButton, gbc);
        
        pack();
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==okButton){
			notify();
		}
		
	}
}
