package mpi.eudico.client.annotator.lexica;

import java.util.ArrayList;
import java.util.List;

/**
 * Each LexiconField can have a list of attributes that complete the field information
 * such as underline_form, glose language etc.
 * @author Coralie
 *
 */
public class LexiconField {
	//the name of the field witch will appears as a tag
	private String fieldName;
	//the value of the field witch will appears as the tag value
	private String fieldValue;
	//parameters of the tag
	private List<String> parameterField;
	private List<String> parameterValue;
	
	//used to add lexiconFields under the current LexiconField in the xml hierarchy
	private List<LexiconField> subLexiconField;
	
	//used to create a relation between two lexiconField
	//private List<LexiconField> relatedLexiconField;
	
	public LexiconField(String fieldName, String fieldValue){
		this.fieldName=fieldName;
		this.fieldValue=fieldValue;
		parameterField=new ArrayList<String>();
		parameterValue=new ArrayList<String>();
		//relatedLexiconField=new ArrayList<LexiconField>();
		subLexiconField=new ArrayList<LexiconField>();
	}
	
	public void addParameter(String key, String value){
		parameterField.add(key);
		parameterValue.add(value);
	}
	
	public int parameterSize(){
		return parameterField.size();
	}
	
	public List<String> getParameters(int i){
		List<String> parameter=new ArrayList<String>();
		parameter.add(parameterField.get(i));
		parameter.add(parameterValue.get(i));
		return parameter;
	}
	
	public String getFieldName(){
		return fieldName;
	}
	
	public String getFieldValue(){
		return fieldValue;
	}
	
	public List<LexiconField> getsubLexiconFields(){
		return subLexiconField;
	}
	
	public void addsubLexiconField(LexiconField lexiconField){
		subLexiconField.add(lexiconField);
	}
}