package mpi.eudico.client.annotator.lexica;

import java.util.ArrayList;
import java.util.List;

public class LexiconRef {
	private String morphemeForm;
	private List<LexiconTableContent> lexicons;
	
	public LexiconRef(String form){
		this.setMorphemeForm(form);
		lexicons=new ArrayList<LexiconTableContent>();
	}
	
	public void addLexicon(LexiconTableContent lexicon){
		lexicons.add(lexicon);
	}
	
	public void addLexiconList(List<LexiconTableContent> lexicons){
		this.lexicons.addAll(lexicons);
	}

	public void setMorphemeForm(String morphemeForm) {
		this.morphemeForm = morphemeForm;
	}

	public String getMorphemeForm() {
		return morphemeForm;
	}
	
	public List<LexiconTableContent> getLexicons(){
		return lexicons;
	}
	
	public boolean equals(LexiconRef lexiconRef){
		if (morphemeForm.equals(lexiconRef.getMorphemeForm())){
			if(lexicons.size()==lexiconRef.getLexicons().size()){
				if(lexicons.size()==0){
					return true;
				}
				for(int i=0; i<lexicons.size(); i++){
					if(!lexicons.get(i).equals(lexiconRef.getLexicons().get(i))){
						return false;
					}
				}
			}
			else{
				return false;
			}
		}
		else{
			return false;
		}
		return true;
	}
}
