package mpi.eudico.client.annotator.lexica;

import java.awt.Component;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableModel;

import mpi.eudico.client.annotator.Constants;
import mpi.eudico.client.annotator.viewer.AbstractViewer;

public class LexiconRenderer implements TableCellRenderer, ItemListener{
	
	protected final AbstractViewer viewer;
	protected final TableModel tableModel;
	
	private JLabel component;
	 
	public LexiconRenderer(AbstractViewer viewer, TableModel tableModel) {
		this.viewer=viewer;
		this.tableModel=tableModel;
		
	}
	
	public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
		String columnName = table.getColumnName(column);
		if (LexiconTableModel.TIMEPOINT.equals(columnName)) {
            if (viewer != null) {
                //create icons only if cell size has changed
                int iconWidth = table.getCellRect(row, column, true).width - 1;
                int iconHeight = table.getCellRect(row, column, true).height -1;
            }
        }

		JLabel label=new JLabel((String) value);
		label.setOpaque(true);
		component=label;
		component.setEnabled(true);
		setComponentLayout(component, table, isSelected);
        setAlignment(component, table.getColumnName(column));
		return component; 
	}

	protected static void setComponentLayout(JComponent component,JTable table, boolean isSelected) {
		component.setFont(table.getFont());
		component.setBorder(BorderFactory.createEmptyBorder(0,1, 0, 3));
		component.setBackground(isSelected ? Constants.SELECTIONCOLOR: table.getBackground());
	}
	  
	protected static void setAlignment(JComponent component, String columnName) {
		if (LexiconTableModel.COUNT.equals(columnName) ||
				LexiconTableModel.LX.equals(columnName) ||
				LexiconTableModel.GE.equals(columnName) ||
				LexiconTableModel.RX.equals(columnName) ||
				LexiconTableModel.A.equals(columnName) ||
				LexiconTableModel.U.equals(columnName)) {
          component.setAlignmentX((SwingConstants.RIGHT));
      } else {
          component.setAlignmentX(SwingConstants.LEFT);
      }
	}
	  
	@Override
	public void itemStateChanged(ItemEvent e) {
		// TODO Auto-generated method stub
		if (e.getStateChange() == ItemEvent.SELECTED){
			
		}
	}
}