package mpi.eudico.client.annotator.lexica;

import java.util.ArrayList;
import java.util.List;

import org.jdom.Element;

/**
 * Object that keep each lexicon table values (interface values)
 * @author Coralie
 *
 */
public class LexiconTableContent implements Comparable {
	private int gridIndex; 
	private Element lexemeElmt;
	//private List<Element> altFormElement;
	private String lx;
	private String ge;
	private String der="";
	private String rx;
	private List<Element> segmentElementList;
	private List<String> segmentList;
	//private String u;
	//private HashMap<String, List<Element>> variantMapList;
	private List<LexiconVariantContent> lexiconVariantList;
	//private List<String> variantList;
	private String type;
	private String associatedLexicalEntryId;

//	private List<VariantTableContent> variantList;
	private ParsingMorpheme parsingMorpheme;
	
	
	public LexiconTableContent(int gridIndex){
		this.setGridIndex(gridIndex);
		setSegmentElementList(new ArrayList<Element>());
		//setVariantlist(new ArrayList<String>()); 
		setLexiconVariantList(new ArrayList<LexiconVariantContent>());
		//setVariantMapList(new HashMap<String, List<Element>>());
		setSegmentList(new ArrayList<String>());
		setParsingMorpheme(null);
	}

	public void setGridIndex(int gridIndex) {
		this.gridIndex = gridIndex;
	}
	
	/**
	 * the lexicalEntry id in the jdom file
	 * @param id
	 */
	public void setAssociatedLexicalEntryId(String id){
		associatedLexicalEntryId=id;
	}
	
	public String getAssociatedLexicalEntryId(){
		return associatedLexicalEntryId;
	}

	public int getGridIndex() {
		return gridIndex;
	}

	public void setType(String type){
		this.type=type;
	}
	
	public void setLx(String lx) {
		this.lx=lx;
	}

	public String getLx() {
		return lx;
	}

	public void setGe(String ge) {
		this.ge=ge;
	}

	public String getGe() {
		return ge;
	}

	public String getType(){
		return type;
	}

	public void setRx(String rx) {
		this.rx=rx;
	}

	public String getRx() {
		return rx;
	}

//	public void setVariantlist(List<String> variantList) {
//		this.variantList=variantList;
//	}
//	
//	public void addVariant(String variant){
//		variantList.add(variant);
//	}

//	public List<String> getVariantList() {
//		return variantList;
//	}
//
	public void setLexemeElmt(Element lexemeElmt) {
		this.lexemeElmt=lexemeElmt;
	}

	public Element getLexemeElmt() {
		return lexemeElmt;
	}

	public void addSegment(String segment){
		segmentList.add(segment);
	}
	
	public void setSegmentList(List<String> segmentList) {
		this.segmentList = segmentList;
	}

	public List<String> getSegmentList() {
		return segmentList;
	}
	
	public void addSegmentElement(Element element){
		segmentElementList.add(element);
	}

	public void setSegmentElementList(List<Element> segmentElementList) {
		this.segmentElementList = segmentElementList;
	}

	public List<Element> getSegmentElementList() {
		return segmentElementList;
	}

	@Override
	public int compareTo(Object o) {
		return new Integer(gridIndex).compareTo(((LexiconTableContent) o).gridIndex);
	}

	public void setParsingMorpheme(ParsingMorpheme parsingMorpheme) {
		this.parsingMorpheme = parsingMorpheme;
	}

	public ParsingMorpheme getParsingMorpheme() {
		return parsingMorpheme;
	}

//	public void addVariantMap(String variant, List<Element> elements){
//		variantMapList.put(variant, elements);
//	}
//	
//	public void setVariantMapList(HashMap<String, List<Element>> variantMapList) {
//		this.variantMapList = variantMapList;
//	}
//
//	public HashMap<String, List<Element>> getVariantMapList() {
//		return variantMapList;
//	}

	public void addLexiconVariantContent(LexiconVariantContent content){
		lexiconVariantList.add(content);
	}
	
	public void setLexiconVariantList(List<LexiconVariantContent> lexiconVariantList) {
		this.lexiconVariantList = lexiconVariantList;
	}

	public List<LexiconVariantContent> getLexiconVariantList() {
		return lexiconVariantList;
	}

	public void setDer(String der) {
		this.der = der;
	}

	public String getDer() {
		return der;
	}
}