package mpi.eudico.client.annotator.lexica;

import java.util.List;

import javax.swing.table.AbstractTableModel;


public class ParseChoiceTableModel extends AbstractTableModel{

	private List<ParseRef> parseRefList;
	
	public ParseChoiceTableModel(List<ParseRef> parseRefList){
		this.parseRefList=parseRefList;
	}
	
	@Override
	public boolean isCellEditable(int row, int column) {
		return false;
	}
	
	@Override
	public int getColumnCount() {
		int maxSegment=0;
		for(ParseRef parseRef:parseRefList){
			if(parseRef.getSegment().size()>maxSegment){
				maxSegment=parseRef.getSegment().size();
			}
		}
		return maxSegment;
	}

	@Override
	public int getRowCount() {
		return parseRefList.size();
	}

	@Override
	public Object getValueAt(int row, int column) {
		ParseRef parseRef=parseRefList.get(row);
		Segment segment=parseRef.getSegment().get(column);
		return segment;
	}

}
