package mpi.eudico.client.annotator.lexica;

import java.awt.Component;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.LineBorder;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableModel;

import mpi.eudico.client.annotator.Constants;

public class ParseChoiceTableRenderer implements TableCellRenderer {
	private JTextField component;
	
	public ParseChoiceTableRenderer(TableModel tableModel){
		component=new JTextField();
	}
	
	@Override
	public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
		if (value instanceof Segment){
			Segment segment=(Segment)value;
			component.setText(segment.getLexeme()+"("+segment.getGloss()+" ; "+segment.getRx()+")");
		}
		component.setOpaque(true);
		component.setEnabled(true);
		
		boolean isActive=false;
		if(table.getSelectedColumn()==column &&row==table.getSelectedRow()&&table.getValueAt(row, column)!=null){
			isActive=true;
		}
		setComponentLayout(component, table, isSelected, isActive);
        setAlignment(component, table.getColumnName(column));
		return component; 
	}
	
	protected static void setComponentLayout(JComponent component,JTable table, boolean isSelected, boolean isActive) {
		component.setFont(table.getFont());
		component.setBorder(BorderFactory.createEmptyBorder(0,1, 0, 3));
		component.setBackground(isSelected ? Constants.SELECTIONCOLOR: table.getBackground());
		component.setBorder(isActive ? new LineBorder(Constants.ACTIVEANNOTATIONCOLOR): table.getBorder());
	}
	  
	protected static void setAlignment(JComponent component, String columnName) {
		component.setAlignmentX(SwingConstants.CENTER);
	}

}
