package mpi.eudico.client.annotator.lexica;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import mpi.eudico.client.annotator.viewer.AbstractViewer;

public class ParseDataChoiceDialog extends JFrame implements MouseListener {
	private AbstractViewer viewer;
	private InterlinearizationProcess interlinearizationProcess;
	private JTable table;
	//private List<ParseRef> parseRefList;
	
	
	public ParseDataChoiceDialog(AbstractViewer viewer, List<ParseRef> parseRefList, InterlinearizationProcess interlinearizationProcess){
		this.viewer=viewer;
		this.interlinearizationProcess=interlinearizationProcess;
		//this.parseRefList=new ArrayList<ParseRef>();
		//this.parseRefList=parseRefList;
		ParseChoiceTableModel model=new ParseChoiceTableModel(parseRefList);
		table=new JTable(model);
		table.setDefaultRenderer(Object.class, new ParseChoiceTableRenderer(model));
		init();
	}
	
	private void init(){
		JScrollPane scrollPane=new JScrollPane(table);
		table.addMouseListener(this);
		add(scrollPane);
		pack();
		setLocationRelativeTo(getParent());
	}

	@Override
	public void mouseClicked(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseEntered(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseExited(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mousePressed(MouseEvent e) {
		int selectedRow=table.getSelectedRow();
		if(e.getSource()==table){
			if (e.getClickCount()>=2){
				List<Segment> segmentList=new ArrayList<Segment>();
				for(int column=0; column<table.getColumnCount(); column++){
					segmentList.add((Segment)table.getValueAt(selectedRow, column));					
				}
				interlinearizationProcess.annotateTier(viewer, segmentList);
				this.dispose();
			}
		}
	}

	@Override
	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

}
