package mpi.eudico.client.annotator.lexica;

import java.util.ArrayList;
import java.util.List;

/**
 * ParsingMorpheme
 * Object to associate a morpheme with segments
 * @author Coralie
 *
 */
public class ParsingMorpheme {
	private String morphemeToParse;
	private List<String> lexiconMorphemesList;
	private List<LexiconRef> lexiconRefList;
	private List<String> lexiconRefIdList;
	private String associatedId;
	
	public ParsingMorpheme(String morphemeToParse, String id){
		this.setAssociatedId(id);
		this.lexiconRefList=new ArrayList<LexiconRef>();
		this.lexiconMorphemesList=new ArrayList<String>();
		this.lexiconRefIdList=new ArrayList<String>();
		this.setMorphemeToParse(morphemeToParse);
	}
	
	public ParsingMorpheme(String morphemeToParse, String id, List<String> morphemes, List<LexiconRef> lexiconRefList){
		this.setAssociatedId(id);
		this.lexiconRefList=new ArrayList<LexiconRef>();
		this.lexiconMorphemesList=new ArrayList<String>();
		setLexiconMorphemesList(morphemes);
		this.setMorphemeToParse(morphemeToParse);
		this.setLexiconRefList(lexiconRefList);
		
	}

	public void addLexiconRefId(String id){
		lexiconRefIdList.add(id);
	}
	
	public List<String> getLexiconRefIds(){
		return lexiconRefIdList;
	}

	public void setLexiconRefids(List<String> idList){
		lexiconRefIdList=idList;
	}
	
	public void addMorpheme(String morpheme){
		lexiconMorphemesList.add(morpheme);
	}
	
	public void generateLexiconRefList(List<LexiconIdConnectionToTableContent> id_TableContentList){
		//System.out.println("morphemeListSize="+lexiconMorphemesList.size());
		//System.out.println("RefIdListSize="+lexiconRefIdList.size());
		if(lexiconMorphemesList.size()==lexiconRefIdList.size()){
			for(int i=0; i<lexiconRefIdList.size(); i++){
				String id=lexiconRefIdList.get(i);
				for(LexiconIdConnectionToTableContent id_TableContent:id_TableContentList){
					if(id_TableContent.getLexiconId().equals(id)){
//						System.out.println("id="+id_TableContent.getLexiconId());
//						System.out.println("tableContent="+id_TableContent.getTableContentList());
//						System.out.println("lexiconMorpheme="+lexiconMorphemesList.get(i));
//						for(LexiconTableContent tableContent:id_TableContent.getTableContentList()){
//							System.out.println("lx="+tableContent.getLx());
//						}
						LexiconRef lexiconRef=new LexiconRef(lexiconMorphemesList.get(i));
						lexiconRef.addLexiconList(id_TableContent.getTableContentList());
						lexiconRefList.add(lexiconRef);
						//break;
					}
				}
			}
		}
	}
	
	public void setMorphemeToParse(String morphemeToParse) {
		this.morphemeToParse = morphemeToParse;
	}

	public String getMorphemeToParse() {
		return morphemeToParse;
	}

	public void setLexiconRefList(List<LexiconRef> lexiconRefList) {
		this.lexiconRefList = lexiconRefList;
	}
	
	public List<LexiconRef> getLexiconRefList() {
		return lexiconRefList;
	}
	
	public void setLexiconMorphemesList(List<String> morphemeList){
		lexiconMorphemesList=morphemeList;
	}
	
	public List<String> getLexiconMorphemesList(){
		return lexiconMorphemesList;
	}

	public void setAssociatedId(String associatedId) {
		this.associatedId = associatedId;
	}

	public String getAssociatedId() {
		return associatedId;
	}
}
