package mpi.eudico.client.annotator.lexica;

import java.util.ArrayList;
import java.util.List;

import org.jdom.Element;

public class SegmentToDefine {
	private String morphemeToParse;
	private List<SegmentElements> segmentElementsList;
	
	public SegmentToDefine(String morphemeToParse){
		this.morphemeToParse=morphemeToParse;
		segmentElementsList=new ArrayList<SegmentElements>();
	}
	
	public void addSegmentToDefine(String segment, List<Element> possibilities){
		segmentElementsList.add(new SegmentElements(segment, possibilities));
	}
	
	public String getMorphemeToParse(){
		return morphemeToParse;
	}
	
	public int getSegmentElementsListSize(){
		return segmentElementsList.size();
	}
	
	public String getSegmentForm(int i){
		SegmentElements segmentElmt=segmentElementsList.get(i);
		return segmentElmt.getSegment();
	}
	
	public List<Element> getReferencePossibilities(int i){
		SegmentElements segmentElmt=segmentElementsList.get(i);
		return segmentElmt.getPossibilities();
	}
	
	private class SegmentElements{
		private String segment;
		private List<Element> referencePossibilities;
		
		public SegmentElements(String segment, List<Element> possibilities){
			this.referencePossibilities=new ArrayList<Element>();
			this.referencePossibilities=possibilities;
			this.segment=segment;
		}
		
		public String getSegment(){
			return segment;
		}
		
		public List<Element> getPossibilities(){
			return referencePossibilities;
		}
	}
}
