package mpi.eudico.client.annotator.lexica.gui;

import mpi.eudico.client.annotator.viewer.AbstractViewer;
import mpi.eudico.server.corpora.clom.Transcription;
import mpi.eudico.server.corpora.clomimpl.abstr.TierImpl;

/**Store information on the annotation hierarchy
 * @author Coralie
 * */
public class AnnotationTierHierarchyInfos {
	private AbstractViewer viewer;
	private Transcription transcription;
	
	private boolean correctHierarchy;
	private boolean correctParseLingType;
	private boolean correctGlossLingType;
	private boolean correctPosLingType;
	
	private TierImpl interlWordTier;
	private TierImpl interlParseTier;
	private TierImpl interlGlossTier;
	private TierImpl interlPosTier;
	
	private TierImpl annParseTier;
	private TierImpl annGlossTier;
	private TierImpl annPosTier;
	
	public AnnotationTierHierarchyInfos(AbstractViewer viewer, Transcription transcription){
		this.viewer=viewer;
		this.setTranscription(transcription);
		setInterlWordTier(null);
		setInterlParseTier(null);
		setInterlGlossTier(null);
		setInterlPosTier(null);
		annParseTier=null;
		annGlossTier=null;
		annPosTier=null;
	}

	public void setCorrectHierarchy(boolean correctHierarchy) {
		this.correctHierarchy = correctHierarchy;
	}

	public boolean isCorrectHierarchy() {
		return correctHierarchy;
	}

	public void setCorrectParseLingType(boolean correctParseLingType) {
		this.correctParseLingType = correctParseLingType;
	}

	public boolean isCorrectParseLingType() {
		return correctParseLingType;
	}

	public void setCorrectGlossLingType(boolean correctGlossLingType) {
		this.correctGlossLingType = correctGlossLingType;
	}

	public boolean isCorrectGlossLingType() {
		return correctGlossLingType;
	}

	public void setCorrectPosLingType(boolean correctPosLingType) {
		this.correctPosLingType = correctPosLingType;
	}

	public boolean isCorrectPosLingType() {
		return correctPosLingType;
	}

	public void setTranscription(Transcription transcription) {
		this.transcription = transcription;
	}

	public Transcription getTranscription() {
		return transcription;
	}

	public void setAnnParseTier(TierImpl annParseTier) {
		this.annParseTier = annParseTier;
	}

	public TierImpl getAnnParseTier() {
		return annParseTier;
	}

	public void setAnnGlossTier(TierImpl annGlossTier) {
		this.annGlossTier = annGlossTier;
	}

	public TierImpl getAnnGlossTier() {
		return annGlossTier;
	}

	public void setAnnPosTier(TierImpl annPosTier) {
		this.annPosTier = annPosTier;
	}

	public TierImpl getAnnPosTier() {
		return annPosTier;
	}

	public void setInterlWordTier(TierImpl interlWordTier) {
		this.interlWordTier = interlWordTier;
	}

	public TierImpl getInterlWordTier() {
		return interlWordTier;
	}

	public void setInterlParseTier(TierImpl interlParseTier) {
		this.interlParseTier = interlParseTier;
	}

	public TierImpl getInterlParseTier() {
		return interlParseTier;
	}

	public void setInterlGlossTier(TierImpl interlGlossTier) {
		this.interlGlossTier = interlGlossTier;
	}

	public TierImpl getInterlGlossTier() {
		return interlGlossTier;
	}

	public void setInterlPosTier(TierImpl interlPosTier) {
		this.interlPosTier = interlPosTier;
	}

	public TierImpl getInterlPosTier() {
		return interlPosTier;
	}

}
