package mpi.eudico.client.annotator.lexica.gui;

import java.awt.Component;
import java.awt.event.ActionListener;
import javax.swing.Action;
import javax.swing.ComboBoxEditor;
import javax.swing.JButton;
import javax.swing.JComboBox;

import mpi.eudico.client.annotator.viewer.LexiconViewer;

/**
 * Mixed between JButton and JComboBox
 * @author Coralie
 *
 */
public class ComboButton {
	public static String SHOW_EDIT_RECORD="Show/Edit Record";
	public static String SHOW_EDIT_VARIANT="Show/Edit Variant";
	public static String INSERT_RECORD="Insert Record";
	public static String INSERT_VARIANT="Insert Variant";
	
	private LexiconViewer lxViewer;
	private JComboBox jcb;
	
	    public ComboButton(LexiconViewer viewer, String action1, String action2){
	    	lxViewer=viewer;
	    	initUI(action1, action2);
	    }
	    
	    private void initUI(String action1, String action2){
	        Action 
	            a = new LXButtonAction(lxViewer, action1),
	            b = new LXButtonAction(lxViewer, action2);
	        
	        jcb = new JComboBox( new Action[]{a,b});
	        
	        jcb.setEditor(new ButtonEditor());
	        jcb.setEditable(true);
	    }
	    
	    public JComboBox getComboButton(){
	    	return jcb;
	    }
	    
	    static class ButtonEditor implements ComboBoxEditor {
	    	private final JButton
	    	delegate = new JButton();

	    	
	    	/**
			 * Constructor. Sets a property on the button for MacOS
			 */
			public ButtonEditor() {
				super();
				delegate.putClientProperty("JButton.buttonType", "gradient");//square
			}

			@Override
	    	public void addActionListener(ActionListener l){
	    		//NOOP
	    	}

	    	@Override
	    	public Component getEditorComponent(){
	    		return delegate;
	    	}

	    	@Override
	    	public Object getItem(){
	    		return delegate.getAction();
	    	}

	    	@Override
	    	public void removeActionListener(ActionListener l){
	    		//NOOP
	    	}

	    	@Override
	    	public void selectAll(){
	    		delegate.doClick();
	    	}

	    	@Override
	    	public void setItem(Object anObject){
	    		if( ! (anObject instanceof Action) ){
	    			throw new IllegalArgumentException(
	    					String.format("Expected Action Object; found: %s", anObject.getClass())
	    			);
	    		}
	    		delegate.setAction( (Action) anObject );
	    	}
	    }
}
