package mpi.eudico.client.annotator.lexica.gui;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JOptionPane;

import mpi.eudico.client.annotator.lexica.LexiconDocumentData;
import mpi.eudico.client.annotator.lexica.record.InsertLXDataDialog;
import mpi.eudico.client.annotator.lexica.record.InsertVariantDataDialog;
import mpi.eudico.client.annotator.lexica.record.ShowEditLXDataDialog;
import mpi.eudico.client.annotator.lexica.record.ShowEditVariantDataDialog;
import mpi.eudico.client.annotator.viewer.LexiconViewer;

/**
 * Action for ComboButton
 * @author Coralie
 *
 */
public class LXButtonAction extends AbstractAction {
	private LexiconViewer lxViewer;

	public LXButtonAction(LexiconViewer lxViewer, String name){
		super(name);
		this.lxViewer=lxViewer;
	}
	@Override
	public String toString(){
		return (String) getValue(Action.NAME);
	}

	@Override
	public void actionPerformed(ActionEvent e){
		if(e.getActionCommand()==ComboButton.INSERT_RECORD){
			if(LexiconDocumentData.DOCUMENT==null){
				JOptionPane.showMessageDialog(null, "You should create or load lexicon by the lexicon menu", "Error", JOptionPane.ERROR_MESSAGE);
			}else{
				new InsertLXDataDialog(lxViewer).setVisible(true);				
			}
		} 
		else if(e.getActionCommand()==ComboButton.INSERT_VARIANT){
			if(LexiconDocumentData.DOCUMENT==null){
				JOptionPane.showMessageDialog(null, "You should create or load lexicon by the lexicon menu", "Error", JOptionPane.ERROR_MESSAGE);				
			}else{
				new InsertVariantDataDialog(lxViewer).setVisible(true);
			}
		} else if(e.getActionCommand()==ComboButton.SHOW_EDIT_RECORD){
			if(LexiconDocumentData.DOCUMENT==null){
				JOptionPane.showMessageDialog(null, "You should create or load lexicon by the lexicon menu", "Error", JOptionPane.ERROR_MESSAGE);
			}else{
				new ShowEditLXDataDialog(lxViewer).setVisible(true);
			}
		}else if (e.getActionCommand()==ComboButton.SHOW_EDIT_VARIANT){
			if(LexiconDocumentData.DOCUMENT==null){
				JOptionPane.showMessageDialog(null, "You should create or load lexicon by the lexicon menu", "Error", JOptionPane.ERROR_MESSAGE);				
			}else{
				new ShowEditVariantDataDialog(lxViewer).setVisible(true);
			}
		}
	}
}
