package mpi.eudico.client.annotator.lexica.gui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

import mpi.eudico.client.annotator.lexica.LexiconDocumentData;
import mpi.eudico.client.annotator.lexica.record.InsertLXDataDialog;
import mpi.eudico.client.annotator.lexica.record.InsertVariantDataDialog;
import mpi.eudico.client.annotator.lexica.record.ShowEditLXDataDialog;
import mpi.eudico.client.annotator.lexica.record.ShowEditVariantDataDialog;
import mpi.eudico.client.annotator.viewer.AbstractViewer;
import mpi.eudico.client.annotator.viewer.LexiconViewer;

public class LexiconRecordPanel extends JPanel implements ActionListener{

	private AbstractViewer lxViewer;
	private TitledBorder border;
	private JPanel buttonPanel;
	private ComboButton insertNewRecordButton;
	private JButton insertVariantButton;
	private JButton showEditVariantButton;
	private ComboButton showEditRecordButton;
	
	public LexiconRecordPanel(AbstractViewer viewer){
		lxViewer=viewer;
		//border = new TitledBorder(ElanLocale.getString("LexiconViewer.Label.Lexicon"));
        //setBorder(border);
        //setLayout(new BorderLayout());

        buttonPanel = new JPanel();
//        GridBagLayout gridbag=new GridBagLayout();
//        Insets insets = new Insets(2, 6, 2, 6);
//		buttonPanel.setLayout(gridbag);
//		GridBagConstraints gbc = new GridBagConstraints();
//		gbc.insets=insets;
//        
//		gbc.gridx=0;
//		gbc.gridy=0;
		
		FlowLayout flowLayout=new FlowLayout(1,0,0);  //CC ()
		buttonPanel.setLayout(flowLayout);
	
		insertNewRecordButton=new ComboButton((LexiconViewer)viewer, ComboButton.INSERT_RECORD, ComboButton.INSERT_VARIANT);
		buttonPanel.add(insertNewRecordButton.getComboButton());
		//insertNewRecordButton=new JButton(ElanLocale.getString("LexiconViewer.Button.New"));
        //insertNewRecordButton.addActionListener(this);
        //buttonPanel.add(b);
        
        
//    	gbc.gridx=1;    
//        insertVariantButton=new JButton(ElanLocale.getString("LexiconViewer.Button.Variant"));
//        insertVariantButton.addActionListener(this);
//        buttonPanel.add(insertVariantButton);

  //  	gbc.gridx=2;
        showEditRecordButton=new ComboButton((LexiconViewer)viewer, ComboButton.SHOW_EDIT_RECORD, ComboButton.SHOW_EDIT_VARIANT);
        buttonPanel.add(showEditRecordButton.getComboButton());
//        showEditRecordButton=new JButton("Show/Edit Record");
//        showEditRecordButton.addActionListener(this);
//        buttonPanel.add(b2);
        
    //    gbc.gridx=3;
     //   showEditVariantButton=new JButton("Show/Edit Variant");
     //   showEditVariantButton.addActionListener(this);
       // buttonPanel.add(showEditVariantButton);
             

 
        add(buttonPanel, BorderLayout.SOUTH);
 
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==insertNewRecordButton) {
			if(LexiconDocumentData.DOCUMENT==null){
				JOptionPane.showMessageDialog(this, "You should create or load lexicon by the lexicon menu", "Error", JOptionPane.ERROR_MESSAGE);
			}else{
				new InsertLXDataDialog(lxViewer).setVisible(true);				
			}
		}
		else if(e.getSource()==insertVariantButton){
			if(LexiconDocumentData.DOCUMENT==null){
				JOptionPane.showMessageDialog(this, "You should create or load lexicon by the lexicon menu", "Error", JOptionPane.ERROR_MESSAGE);				
			}else{
				new InsertVariantDataDialog(lxViewer).setVisible(true);
			}
		}
		else if(e.getSource()==showEditRecordButton){
			if(LexiconDocumentData.DOCUMENT==null){
				JOptionPane.showMessageDialog(this, "You should create or load lexicon by the lexicon menu", "Error", JOptionPane.ERROR_MESSAGE);
			}else{
				new ShowEditLXDataDialog(lxViewer).setVisible(true);
			}
		}
		else if(e.getSource()==showEditVariantButton){
			if(LexiconDocumentData.DOCUMENT==null){
				JOptionPane.showMessageDialog(this, "You should create or load lexicon by the lexicon menu", "Error", JOptionPane.ERROR_MESSAGE);				
			}else{
				new ShowEditVariantDataDialog(lxViewer).setVisible(true);
			}
		}
	}
}
