package mpi.eudico.client.annotator.lexica.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Font;
import javax.swing.ButtonGroup;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JTable;
//import java.lang.String;


import mpi.eudico.client.annotator.Constants;
import mpi.eudico.client.annotator.ElanLocale;
import mpi.eudico.client.annotator.lexica.record.InsertLXDataDialog;
import mpi.eudico.client.annotator.lexica.record.InsertVariantDataDialog;
import mpi.eudico.client.annotator.viewer.AbstractViewer;

public class LexiconSegmentationPanelPopUpMenu extends JPopupMenu implements ActionListener{

	private AbstractViewer viewer;
	private JTable table;
	private String morphemeToAdd;
	private JMenuItem insertRecordItem;
	private JMenuItem insertVariantItem;
	private JMenu fontMenu;
	private ButtonGroup fontSizeBG;
	private Font font;
	
	public LexiconSegmentationPanelPopUpMenu(JTable table, AbstractViewer viewer/*, String morpheme*/) {
		this.table=table;
    	this.viewer=viewer;
    	
    	font=table.getFont();
    	
    	insertRecordItem=new JMenuItem();
		insertRecordItem.addActionListener(this);
		insertRecordItem.setActionCommand("INSERTRECORD");
		
		insertVariantItem=new JMenuItem();
		insertVariantItem.addActionListener(this);
		insertVariantItem.setActionCommand("INSERTVARIANT");
		
		fontSizeBG=new ButtonGroup();
		fontMenu=new JMenu(ElanLocale.getString("Menu.View.FontSize"));

        JRadioButtonMenuItem fontRB;

        for (int i = 0; i < Constants.FONT_SIZES.length; i++) {
            fontRB = new JRadioButtonMenuItem(String.valueOf(Constants.FONT_SIZES[i]));
            fontRB.setActionCommand("font" + Constants.FONT_SIZES[i]);

            if(font.getSize()==Constants.FONT_SIZES[i]) {
                fontRB.setSelected(true);
            }

            fontRB.addActionListener(this);
            fontSizeBG.add(fontRB);
            fontMenu.add(fontRB);
        }
	}
	
	public void setMorpheme(String morpheme){
		if (morpheme.substring(0,1).equals("*")){ 		// CC 31/03/2011
			this.morphemeToAdd = morpheme.substring(1);
		}
		else { this.morphemeToAdd = morpheme; }
		insertRecordItem.setText(ElanLocale.getString("LexiconViewer.Button.New") + " '" + this.morphemeToAdd + "'");
		insertVariantItem.setText(ElanLocale.getString("LexiconViewer.Button.Variant")+ " '" + this.morphemeToAdd + "'");
	}
	
	protected void makeLayout() {
        removeAll();
        add(insertRecordItem).setFont(font);	// CC 31/03/2011
        add(insertVariantItem).setFont(font);	// CC
        addSeparator();
        add(fontMenu);
        
	}

	public void setVisible(boolean b) {
		if (b) {
			makeLayout();
		}
		super.setVisible(b);
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		 String actionCommand = e.getActionCommand();
		  if (actionCommand.equals("INSERTRECORD")){
				InsertLXDataDialog newDialog=new InsertLXDataDialog(viewer, morphemeToAdd);
				newDialog.setVisible(true);
		  } else if(actionCommand.equals("INSERTVARIANT")){
			  InsertVariantDataDialog newDialog=new InsertVariantDataDialog(viewer, morphemeToAdd);
				newDialog.setVisible(true);
		  } else if(actionCommand.indexOf("font")!=-1) {
				  int index=e.getActionCommand().indexOf("font")+4;
				  try {
					  int fontSize=Integer.parseInt(actionCommand.substring(index));
					  table.setFont(font.deriveFont((float) fontSize));
					  //table.setFont(Constants.DEFAULTFONT.deriveFont((float) fontSize));
					  table.setRowHeight((((fontSize + 2) < 16) ? 16 : (fontSize + 3)));
					  table.repaint();
				  } catch (Exception ex){}
		  }
		  //table.doLayout();
	}

}
