package mpi.eudico.client.annotator.lexica.gui;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;

import mpi.eudico.client.annotator.ElanLocale;
import mpi.eudico.client.annotator.viewer.LexiconViewer;
import mpi.eudico.server.corpora.clomimpl.abstr.TierImpl;
import mpi.eudico.server.corpora.clomimpl.abstr.TranscriptionImpl;

public abstract class TierParameterFrame extends JFrame implements ActionListener{
	protected LexiconViewer viewer;
	protected TranscriptionImpl transcription;
	
	protected JComboBox chooseTierCbBox;
	
	protected JButton chooseTierButton;
	private JPanel tierNamePanel;
	
	protected JButton createTiers;
	protected String motValue;
	protected String mbValue;
	protected String geValue;
	protected String rxValue;
	
	protected HashMap<String, String> map;
	
	protected JLabel chooseTierLabel;
	
	protected TitledBorder createTierTitle;
	
	protected List<JLabel> tierLbList;
	protected List<JTextField> tierTxtFdList;
	protected List<JComboBox> lingTypeCbBoxList;
	
	public TierParameterFrame(LexiconViewer viewer, TranscriptionImpl transcription, HashMap<String, String> map){
		this.viewer=viewer;
		this.transcription=transcription;
		this.map=map;
		tierLbList=new ArrayList<JLabel>();
		tierTxtFdList=new ArrayList<JTextField>();
		lingTypeCbBoxList=new ArrayList<JComboBox>();
		initHashMapElements();
		init();
		updateLocale();
		this.setVisible(true);
		pack();
	}
	
	private void init(){
		setLayout(new GridBagLayout());
		GridBagConstraints gbc=new GridBagConstraints();
		Insets insets= new Insets(0, 3, 2, 2);
		gbc.insets=insets;
		gbc.fill=GridBagConstraints.HORIZONTAL;
		gbc.gridx=0;
		gbc.gridy=0;
		chooseTierLabel=new JLabel();
		add(chooseTierLabel, gbc);
		chooseTierCbBox=new JComboBox();
		Vector<TierImpl> tierVector=transcription.getTiers();
		for(TierImpl tierImpl:tierVector){
			chooseTierCbBox.addItem(tierImpl.getName()/*.replaceAll("@"+tierImpl.getParticipant(), "")*/);			
		}
		gbc.gridx=1;
		add(chooseTierCbBox, gbc);
		
		gbc.gridx=2;
		chooseTierButton=new JButton(ElanLocale.getString("Button.OK"));
		chooseTierButton.addActionListener(this);
		add(chooseTierButton, gbc);
		
		gbc.gridy=1;
		gbc.gridx=0;
		gbc.gridwidth=3;
		tierNamePanel=new JPanel();
		tierNamePanel.setLayout(new GridBagLayout());
		add(tierNamePanel, gbc);
	}
	
	abstract void initHashMapElements();
	
	abstract void updateLocale();
	
	abstract void updateLocaleParameterPane();
	
	protected void initParameterPane(){
		createTierTitle=new TitledBorder("");
		tierNamePanel.setBorder(createTierTitle);

		GridBagConstraints gbc=new GridBagConstraints();
		Insets insets= new Insets(0, 3, 2, 2);
		gbc.insets=insets;
		
		int i=0;
		while(i<map.size()-1){
			gbc.gridx=0;
			gbc.gridy=i;
			JLabel tierLabel=new JLabel();
			tierLbList.add(tierLabel);
			tierNamePanel.add(tierLabel, gbc);
			gbc.gridx=1;
			gbc.gridy=i;
			JTextField tierTextField=new JTextField(5);
			tierTxtFdList.add(tierTextField);
			tierNamePanel.add(tierTextField, gbc);
			gbc.gridx=2;
			gbc.gridy=i;
			JLabel lingTypeLabel=new JLabel(ElanLocale.getString("TierParameterFrame.Label.LingType"));
			tierNamePanel.add(lingTypeLabel, gbc);
			gbc.gridx=3;
			gbc.gridy=i;
			JComboBox lingTypeCbBox=new JComboBox();
			lingTypeCbBoxList.add(lingTypeCbBox);
			tierNamePanel.add(lingTypeCbBox, gbc);
			i++;
		}
		gbc.gridy=i;
		gbc.gridx=3;
		createTiers=new JButton(ElanLocale.getString("TierParameterFrame.JButton.Create"));
		createTiers.addActionListener(this);
		tierNamePanel.add(createTiers, gbc);
		
	
	}

	@Override
	public void actionPerformed(ActionEvent e) {

	}
}
