package mpi.eudico.client.annotator.lexica.gui;

import java.awt.event.ActionEvent;
import java.util.HashMap;

import javax.swing.JLabel;
import javax.swing.JTextField;

import mpi.eudico.client.annotator.ElanLocale;
import mpi.eudico.client.annotator.viewer.LexiconViewer;
import mpi.eudico.server.corpora.clomimpl.abstr.TranscriptionImpl;

/**
 * Rename Tier for Annotation
 * By default tier names for annotation are mb, ge, rx
 * @author Coralie
 *
 */
public class TierRenameAnnotationFrame extends TierRenameFrame {
	
	public TierRenameAnnotationFrame(LexiconViewer viewer, TranscriptionImpl transcription, HashMap<String, String> map){
		super(viewer, transcription, map);
	}

	@Override
	void initHashMapElements() {
		mbValue=map.get(LexiconViewer.ANNOTATION_PARSE_TIER_NAME);
		geValue=map.get(LexiconViewer.ANNOTATION_GLOSS_TIER_NAME);
		rxValue=map.get(LexiconViewer.ANNOTATION_POS_TIER_NAME);
	}

	@Override
	void updateLocale() {
		setTitle(ElanLocale.getString("TierRenameFrame.Annotate.Title"));
		for(int i=0; i<labelList.size(); i++){
			JLabel label=labelList.get(i);
			if(i==0){
				label.setText(ElanLocale.getString("TierRenameFrame.JLabel.Segmentation")+mbValue);
			} else if(i==1){
				label.setText(ElanLocale.getString("TierRenameFrame.JLabel.Gloss")+geValue);
			} else if(i==2){
				label.setText(ElanLocale.getString("TierRenameFrame.JLabel.Pos")+rxValue);
			}
		}
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==renameButton){
			for(int i=0; i<textFieldList.size(); i++){
				JTextField textField=textFieldList.get(i);
				if(i==0){
					if(!textField.getText().isEmpty()){
						mbValue=textField.getText();
					}
				} else if(i==1){
					if(!textField.getText().isEmpty()){
						geValue=textField.getText();
					}
				} else if(i==2){
					if(!textField.getText().isEmpty()){
						rxValue=textField.getText();
					}
				}
			}
			viewer.setTierPreferences(LexiconViewer.ANNOTATION_TIER_PARSE, mbValue);
			viewer.setTierPreferences(LexiconViewer.ANNOTATION_TIER_GLOSS, geValue);
			viewer.setTierPreferences(LexiconViewer.ANNOTATION_TIER_POS, rxValue);
			
			this.setVisible(false);
			dispose();
		}
		
	}
}
