package mpi.eudico.client.annotator.lexica.gui;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;

import mpi.eudico.client.annotator.ElanLocale;
import mpi.eudico.client.annotator.viewer.LexiconViewer;
import mpi.eudico.server.corpora.clomimpl.abstr.TranscriptionImpl;

public abstract class TierRenameFrame extends JFrame implements ActionListener{
	protected LexiconViewer viewer;
	private TranscriptionImpl transcription;
	protected String motValue;
	protected String mbValue;
	protected String geValue;
	protected String rxValue;
	protected JButton renameButton;
	
	protected List<JLabel> labelList;
	protected List<JTextField> textFieldList;
	
	protected HashMap<String, String> map;

	public TierRenameFrame(LexiconViewer viewer, TranscriptionImpl transcription, HashMap<String, String> map){
		this.viewer=viewer;
		this.transcription=transcription;
		this.map=map;
		labelList=new ArrayList<JLabel>();
		textFieldList=new ArrayList<JTextField>();
		initHashMapElements();
		init();
		updateLocale();
		this.setVisible(true);
		pack();
	}
	
	public void init(){
		setLayout(new GridBagLayout());
		GridBagConstraints gbc=new GridBagConstraints();
		Insets insets= new Insets(0, 3, 2, 2);
		gbc.insets=insets;
		gbc.fill=GridBagConstraints.HORIZONTAL;
		int i=0;
		while(i<map.size()){
			gbc.gridx=0;
			gbc.gridy=i;
			JLabel label=new JLabel();
			labelList.add(label);
			add(label, gbc);
			gbc.gridx=1;
			gbc.gridy=i;
			JTextField textField=new JTextField(4);
			textFieldList.add(textField);
			add(textField, gbc);
			i++;
		}
		gbc.gridx=0;
		gbc.gridy=i;
		renameButton=new JButton(ElanLocale.getString("TierRenameFrame.JButton.Rename"));
		renameButton.addActionListener(this);
		add(renameButton,gbc);
	}
	
	abstract void updateLocale();
	
	abstract void initHashMapElements();

	@Override
	public void actionPerformed(ActionEvent arg0) {
		
	}
}
