package mpi.eudico.client.annotator.lexica.record;

import java.awt.EventQueue;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.Collections;
import java.util.List;
import java.util.Vector;

import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JTextField;

import org.jdom.Element;

/**
 * http://java-swing-tips.blogspot.fr/2009/01/create-auto-suggest-jcombobox.html
 * Auto-suggest combobox
 *  
 * @author TERAI Atsuhiro
 */
class ComboKeyHandler extends KeyAdapter{
	private final JComboBox comboBox;
	private final Vector<String> list = new Vector<String>();
	private final Vector<Element> LEXEMES = new Vector<Element>(); //UTD

	/**
	 * Constructeur
	 */
	public ComboKeyHandler(JComboBox combo) {
		this.comboBox = combo;
		//System.out.println("size : "+ comboBox.getModel().getSize());
		for(int i=0;i< comboBox.getModel().getSize();i++) {
			if (comboBox.getItemAt(i)!=null) { // UTD 10/09/12 test ajouté pour éviter la NullPointerException dans le cas de la présence d'un élément null
				//System.out.println("combokeyhandler : "+ ((Element) comboBox.getItemAt(i)).getText());
				// Modification PDI
				list.addElement(((Element)comboBox.getItemAt(i)).getText());
				LEXEMES.addElement((Element)comboBox.getItemAt(i));
				//System.out.println("lexeme "+ i + " : " + ((Element) comboBox.getItemAt(i)).getText());
			}
		}
		//System.out.println("------------------------");
	}

	private boolean shouldHide = false;

	@Override public void keyTyped(final KeyEvent e) {
		EventQueue.invokeLater(new Runnable() {
			@Override public void run() {
				String text = ((JTextField)e.getSource()).getText();
				if(text.length()==0) { // UTD : cas où on efface le contenu du textField (on n'y met rien et toute la liste des lexèmes est disponible)
					setSuggestionModel(comboBox, new DefaultComboBoxModel(LEXEMES), "");   // UTD : list remplacé par LEXEMES     	
					comboBox.hidePopup();
				}else{
					ComboBoxModel m = getElementModel(LEXEMES, text);
					if(m.getSize()==0 || shouldHide) {
						comboBox.hidePopup();
					}else{
						setSuggestionModel(comboBox, m, text);
						comboBox.showPopup();
					}
				}
			}
		});
	}

	@Override public void keyPressed(KeyEvent e) {
			JTextField textField = (JTextField)e.getSource();
			String text = textField.getText();
			shouldHide = false;
			switch(e.getKeyCode()) {
			case KeyEvent.VK_RIGHT:				
				for(String s: list) {
					if(s.startsWith(text)) {
						textField.setText(s);
						return;
					}
				}		
				break;
	
			case KeyEvent.VK_ENTER:			
				if(!list.contains(text)) {
					list.addElement(text);
					Collections.sort(list);
					setSuggestionModel(comboBox, getSuggestedModel(list, text), text);
				}
				shouldHide = true;
				break;
			//UTD 06/09/12 : ajout juste pour le test	
			case KeyEvent.VK_ESCAPE:
				System.out.println("vk_enter : "+ comboBox.getSelectedItem().toString());
				if (comboBox.getSelectedItem() instanceof Element) {
					System.out.println("element");
					// rien, c'est bon pour le passage au traitement suivant qui nécessite un objet de type Element
				}else if (comboBox.getSelectedItem() instanceof String) {
					System.out.println("string");
					int index = comboBox.getSelectedIndex();
					Element elt = (Element) LEXEMES.get(index);
					comboBox.setSelectedItem(elt);
					System.out.println("elt :" +index + " - "+elt.getText());
					System.out.println("get elt :" +index + " - "+((Element) comboBox.getSelectedItem()).getText());
				}
				//shouldHide = true; UTD
				break;
			}
/*			//UTD 06/09/12 : ajout juste pour le test	
			case KeyEvent.VK_SPACE:
				setSuggestionModel(comboBox, getOriginalModel(LEXEMES), "");
				break;
			}*/
	}

	private static void setSuggestionModel(
			JComboBox comboBox, ComboBoxModel mdl, String str) {
		comboBox.setModel(mdl);
		comboBox.setSelectedIndex(-1);
		((JTextField)comboBox.getEditor().getEditorComponent()).setText(str);
	}

	private static ComboBoxModel getSuggestedModel(
			Vector<String> list, String text) {
		DefaultComboBoxModel m = new DefaultComboBoxModel();
		for(String s: list) {
			if(s.startsWith(text)) m.addElement(s);
		}
		return m;
	}
	
	/**
	 * UTD : pour récupérer une liste d'éléments et non de string
	 * @param lexemes
	 * @param text
	 * @return
	 */
	private static ComboBoxModel getElementModel(Vector<Element> lexemes, String text) {
		DefaultComboBoxModel m = new DefaultComboBoxModel();
		for (Element elt : lexemes) {
			if(elt.getText().startsWith(text)) m.addElement(elt);
		}
		return m; 
	}
	
	/**
	 * UTD : pour récupèrer la combobox d'origine avec tous les lexèmes
	 * @param list
	 * @return
	 */
	private static ComboBoxModel getOriginalModel(List<Element> lexemes) {
		DefaultComboBoxModel m = new DefaultComboBoxModel();
		for(Element elt: lexemes) {
			m.addElement(elt);
		}
		return m;
	}
	}

