package mpi.eudico.client.annotator.lexica.record;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

import mpi.eudico.client.annotator.ElanLocale;
import mpi.eudico.client.annotator.viewer.AbstractViewer;

/**
 * Add a lexeme in the current selected lexicon file
 * @author Coralie
 *
 */
public class InsertLXRecordPanel extends LXRecordPanel implements ActionListener{
	protected int glosePaneSize;
	private JPanel glosePane;
	protected JButton addGlose;
	private List<GloseTierXSubPane> gloseTierXPaneList;
	
	/**
	 * Create the panel
	 * @param document
	 */
	public InsertLXRecordPanel(AbstractViewer viewer){
		super(viewer);
	}

	public InsertLXRecordPanel(AbstractViewer viewer, String lexemeTxt){
		super(viewer, lexemeTxt);
	}
	
	/**
	 * Init components in the panel
	 */
	@Override
	protected void initComponents(){
		super.initComponents();
		
		lexiconPane.setLayout(new GridLayout(1, 2, 6, 0));
		GridBagConstraints gbc=new GridBagConstraints();
		Insets insets=new Insets(2, 6, 2, 6);
		gbc.gridx=0;
		gbc.gridy=0;
		gbc.insets=insets;
		lexiconPane.add(lexemeLb, gbc);
		gbc.gridx=1;
        lexiconPane.add(lexemeTxtField, gbc);
		
		GridBagLayout gridbag=new GridBagLayout();
		setLayout(gridbag);
		gbc = new GridBagConstraints();
		gbc.gridx=0;
		gbc.gridy=0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets=insets;
		gbc.anchor=GridBagConstraints.NORTH;
		add(lexiconPane, gbc);

		gbc.gridx=0;
		gbc.gridy=1;
		gloseTierXPaneList=new ArrayList<GloseTierXSubPane>();
		glosePane=new JPanel();
		updateGlosePane();
        add(glosePane, gbc);
		
		updateLocale();
	}
	
	/**
	 * Filled glose and Rx informations 
	 */
	private void updateGlosePane(){
		glosePane.setLayout(new GridBagLayout());
		GridBagConstraints gbc=new GridBagConstraints();
		Insets insets=new Insets(2, 6, 2, 6);
		int i=0;
		while(i<=glosePaneSize){
			gbc.insets=insets;
			gbc.gridy=0+i;
			gbc.gridx=0;
			GloseTierXSubPane gloseTierXPane;
			if(i<gloseTierXPaneList.size()){
				gloseTierXPane=gloseTierXPaneList.get(i);
			}
			else{
				gloseTierXPane=new GloseTierXSubPane();
				gloseTierXPaneList.add(gloseTierXPane);
			}
			glosePane.add(gloseTierXPane, gbc);
			i++;
		}
		
		gbc.gridx=i+1;
		addGlose=new JButton();
		addGlose.setText(ElanLocale.getString("Button.Add"));
		addGlose.addActionListener(this);
		glosePane.add(addGlose, gbc);
	}
	
	public List<GloseTierXSubPane> getGloseTierXPaneList(){
		return gloseTierXPaneList;
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==addGlose){
				glosePane.removeAll();
				glosePaneSize++;
				lexemeText=lexemeTxtField.getText();
				updateGlosePane();
				getRootPane().repaint();
				SwingUtilities.windowForComponent(this).pack();
		}
	}
}
