package mpi.eudico.client.annotator.lexica.record;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

import mpi.eudico.client.annotator.lexica.LexiconDocumentData;
import mpi.eudico.client.annotator.viewer.AbstractViewer;
import mpi.eudico.client.annotator.viewer.LexiconViewer;

import org.jdom.Element;

public class InsertParseRecordPanel extends LXRecordPanel implements ActionListener{
	protected JPanel uFormPane;
	//number of uForm's JTextField
	protected int uFormPaneSize=2;
	
	//uForm
	protected JLabel chooseSegmentLb;
	protected List<JComboBox> uFormCbBoxList;
	private JButton addMorphemeButton;
//	
	private List<JButton> showMorphemeButtonList;
	private JLabel orLb;
	private List<JButton> insertMorphemeButtonList;
	
	//new morpheme pane
	private List<Integer> morphemePaneLocation;
	private Map<Integer, MorphemeSubPane> addNewMorphemePaneMap;
	
	public InsertParseRecordPanel(AbstractViewer viewer){
		super(viewer);
	}
	
	public InsertParseRecordPanel(AbstractViewer viewer, String lexemeTxt){
		super(viewer, lexemeTxt);
	}
	
	@Override
	protected void initComponents(){
		super.initComponents();
		GridBagConstraints gbc=new GridBagConstraints();
		Insets insets=new Insets(2, 6, 2, 6);
		uFormPaneSize=2;
		morphemePaneLocation=new ArrayList<Integer>();
		GridBagLayout gridbag=new GridBagLayout();
		setLayout(gridbag);
		gbc.gridx=0;
		gbc.gridy=0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets=insets;
		gbc.anchor=GridBagConstraints.NORTH;
		updateLexiconPane();
		add(lexiconPane, gbc);
		gbc.gridy=1;
		uFormPane=new JPanel();
		uFormCbBoxList=new ArrayList<JComboBox>();
		showMorphemeButtonList=new ArrayList<JButton>();
		insertMorphemeButtonList=new ArrayList<JButton>();
		
		addNewMorphemePaneMap=new HashMap<Integer, MorphemeSubPane>();
		
		Element nullElement=null;
		segmentList.add(nullElement);
		segmentList.add(nullElement);
		
		updateUFormPane();
		add(uFormPane, gbc);
	
        updateLocale();
	}
	
	protected void updateLexiconPane(){
		lexiconPane.setLayout(new GridLayout(1, 2, 6, 0));
		GridBagConstraints gbc=new GridBagConstraints();
		Insets insets=new Insets(2, 6, 2, 6);
		gbc.gridx=0;
		gbc.gridy=0;
		gbc.insets=insets;
		lexiconPane.add(lexemeLb, gbc);
		gbc.gridx=1;
        lexiconPane.add(lexemeTxtField, gbc);
	}
	
//	/**
//	 * Filled parsing informations 
//	 */
//	protected void updateUFormPane(){
//		Insets insets = new Insets(2, 2, 2, 2);
//		GridBagLayout gridbag=new GridBagLayout();
//		uFormPane.setLayout(gridbag);
//		GridBagConstraints gbc=new GridBagConstraints();
//    	gbc.insets=insets;
//    	gbc.anchor=GridBagConstraints.WEST;
//    	int i=0;
//		while(i<segmentList.size()){
//			gbc.gridy=0+i;
//	    	gbc.gridx=0;
//	    	ParseSegmentsSubPane parsePane;
//	    	if(i<parseSegmentPaneList.size()){
//	    		parsePane=(ParseSegmentsSubPane) parseSegmentPaneList.get(i);
//	    	} else{
//	    		parsePane=new ParseSegmentsSubPane(segmentList.get(i));
//	    		parseSegmentPaneList.add(parsePane);
//	    		parsePane.getShowButton().addActionListener(this);
//	    	}
//	    	uFormPane.add(parsePane, gbc);
//	    	i++;
//		}
//		addMorphemeButton=new JButton("Add");
//		addMorphemeButton.addActionListener(this);
//		gbc.gridx=1;
//		gbc.gridy=i+1;
//		uFormPane.add(addMorphemeButton, gbc);
//	}
	
	/**
	 * Filled parsing informations 
	 */
	protected void updateUFormPane(){
		Insets insets = new Insets(2, 2, 2, 2);
		GridBagLayout gridbag=new GridBagLayout();
		uFormPane.setLayout(gridbag);
		GridBagConstraints gbc = new GridBagConstraints();
    	gbc.insets=insets;
    	gbc.anchor=GridBagConstraints.WEST;
    	int i=0; 
		while(i<uFormPaneSize){
			gbc.gridy=0+i;
	    	gbc.gridx=0;
			chooseSegmentLb=new JLabel("Choose Segment "+(i+1));
			uFormPane.add(chooseSegmentLb, gbc);
			gbc.gridx=1;
			JComboBox uFormCbBox;
			if(i<uFormCbBoxList.size()){
				uFormCbBox=uFormCbBoxList.get(i);
			}else{
				// UTD 10/09/12 change JComboBox to JSuggestCombobox
				uFormCbBox=new JSuggestComboBox(LexiconDocumentData.getMorphemesToSelect(false, false).toArray());
				uFormCbBox.setRenderer(new JDomElementListCellRenderer());
				uFormCbBoxList.add(i, uFormCbBox);
			}
			uFormPane.add(uFormCbBox, gbc);
			gbc.gridx=2;
			JButton showMorphemeButton;
			if(i<showMorphemeButtonList.size()){
				showMorphemeButton=showMorphemeButtonList.get(i);
			}else{
				showMorphemeButton=new JButton("Show");
				showMorphemeButtonList.add(i, showMorphemeButton);
			}
			showMorphemeButton.addActionListener(this);
			uFormPane.add(showMorphemeButton, gbc);
			
			gbc.gridx=3;
			orLb=new JLabel("OR");
			uFormPane.add(orLb, gbc);
			
			gbc.gridx=4;
			boolean addbutton=true;
			if(!morphemePaneLocation.isEmpty()){
				for(int j=0; j<morphemePaneLocation.size(); j++){
					if(i==morphemePaneLocation.get(j)){
						MorphemeSubPane newMorphemePane;
						if(addNewMorphemePaneMap.get(i)!=null){
							newMorphemePane=addNewMorphemePaneMap.get(i);
						}
						else{
							newMorphemePane=new MorphemeSubPane();
							addNewMorphemePaneMap.put(new Integer(i), newMorphemePane);
						}
						newMorphemePane.getOkButton().addActionListener(this);
						uFormPane.add(newMorphemePane, gbc);
						addbutton=false;
						break;
					}
				}
			}
			JButton insertMorphemeButton;
			if(i<insertMorphemeButtonList.size()){
				insertMorphemeButton=insertMorphemeButtonList.get(i);
			}else{
				insertMorphemeButton=new JButton("Insert");
				insertMorphemeButtonList.add(i, insertMorphemeButton);
			}
			if(addbutton){
				insertMorphemeButton.addActionListener(this);
				uFormPane.add(insertMorphemeButton, gbc);
			}
			i++;
		}
    	gbc.gridy=i+1;
    	gbc.gridx=4;
    	addMorphemeButton=new JButton("Add Segment");
    	addMorphemeButton.addActionListener(this);
    	uFormPane.add(addMorphemeButton, gbc);
	}
	
	public List<JComboBox> getUFormCbBoxList(){
		return uFormCbBoxList;
	}

	public List<LXSubPanel> getSubPaneList(){
		return parseSegmentPaneList;
	}
	
	private void updateMorphemeToSelectComboBox(int i, Element elementInserted){
		for(int j=0; j<morphemePaneLocation.size(); j++){
			if (morphemePaneLocation.get(j).equals(i)){
				morphemePaneLocation.remove(j);
			}
		}
		LexiconDocumentData.clearAllLists();
		for(int j=0; j<uFormCbBoxList.size(); j++){
			JComboBox uFormCbBox=uFormCbBoxList.get(j);
			uFormCbBox.addItem(elementInserted);
			if(i==j){
				addNewMorphemePaneMap.remove(new Integer(j));
				uFormCbBox.setSelectedItem(elementInserted);
				uFormPane.removeAll();
				updateUFormPane();
				getRootPane().repaint();
				SwingUtilities.windowForComponent(this).pack();
			}
		}
	}
	
	/**
	 * 
	 */
	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==addMorphemeButton){
			uFormPane.removeAll();
			uFormPaneSize++;
			//Element nullElement=null;
			//segmentList.add(nullElement);
			lexemeText=lexemeTxtField.getText();
			updateUFormPane();
			getRootPane().repaint();
			SwingUtilities.windowForComponent(this).pack();
		}
		//show a selected morpheme
//		for(LXSubPanel parsePane:parseSegmentPaneList){
//			if(e.getSource()==parsePane.getShowButton()){
//				Element elementToShow=parsePane.getSelectedUFormElement();
//				if(elementToShow!=null){
//					ShowEditLXDataDialog dialog=new ShowEditLXDataDialog(lxViewer, elementToShow);
//					dialog.setVisible(true);
//				}
//			}
//		}
		for(int j=0; j<insertMorphemeButtonList.size(); j++){
			if (e.getSource().equals(insertMorphemeButtonList.get(j))){
				uFormPane.removeAll();
				morphemePaneLocation.add(j);
				updateUFormPane();
				getRootPane().repaint();
				SwingUtilities.windowForComponent(this).pack();
				break;
			}
		}
		//if the user inserts a new morpheme
		for(int i:addNewMorphemePaneMap.keySet()){
			MorphemeSubPane panel=addNewMorphemePaneMap.get(i);
			String lexeme=panel.getMorphemeTxtField().getText();
			if (e.getSource().equals(panel.getOkButton())){
				if(!lexeme.isEmpty()){
					LXRecordQueries query=new LXRecordQueries(lxViewer);
					Element elementInserted=query.actionInsertMorpheme(panel);
					if(elementInserted!=null){
						((LexiconViewer) lxViewer).updateLexiconChange();
						LexiconDocumentData.incrementMaxId();
						LexiconDocumentData.clearAllLists();
						JOptionPane.showMessageDialog(this,"The record '"+lexeme+"' was successfully inserted","Record Inserted",JOptionPane.INFORMATION_MESSAGE);
						updateMorphemeToSelectComboBox(i, elementInserted);
						break;
					}
					else{
						System.out.println("Please insert Record");
						break;
					}
				}
				else{
					JOptionPane.showMessageDialog(this,"Please insert morpheme information", "Error",JOptionPane.ERROR_MESSAGE);
					break;
				}
			}
		}
		//show a selected morpheme
		for(int i=0; i<showMorphemeButtonList.size(); i++){
			if(e.getSource().equals(showMorphemeButtonList.get(i))){
				if(i<uFormCbBoxList.size()){
					JComboBox associatedComboBox=uFormCbBoxList.get(i);
					Element elementToShow=(Element)associatedComboBox.getSelectedItem();
					if(elementToShow!=null){
						ShowEditLXDataDialog dialog=new ShowEditLXDataDialog(lxViewer, elementToShow);
						dialog.setVisible(true);
					}
				}
				else{
					System.out.println("Error: size list are not equals");
				}
			}
		}
	}
}
