package mpi.eudico.client.annotator.lexica.record;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.jdom.Element;

import mpi.eudico.client.annotator.ElanLocale;
import mpi.eudico.client.annotator.lexica.LexiconDocumentData;
import mpi.eudico.client.annotator.viewer.AbstractViewer;

public class InsertParseVariantToLXRecordPanel extends InsertParseRecordPanel implements ActionListener {
	protected JLabel variantLb;
	protected int lexemeSelectedIndex=0;
	protected JButton showLexiconButton;
	protected JComboBox lexemeCbBox;
	protected JPanel uFormPane;
	
	public InsertParseVariantToLXRecordPanel(AbstractViewer viewer){
		super(viewer);
	}
	
	public InsertParseVariantToLXRecordPanel(AbstractViewer viewer, String lexeme){
		super(viewer, lexeme);
	}

	protected void updateLexiconPane(){
		lexiconPane=new JPanel();
		Insets insets = new Insets(2, 6, 2, 6);
		GridBagLayout gridbag=new GridBagLayout();
		lexiconPane.setLayout(gridbag);
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridx=0;
		gbc.gridy=0;
		gbc.insets=insets;
		gbc.anchor=GridBagConstraints.WEST;
        lexiconPane.add(lexemeLb, gbc);
        gbc.gridx=1;
        lexiconPane.add(lexemeTxtField, gbc);
        gbc.gridx=2;
        variantLb=new JLabel(ElanLocale.getString("LexiconViewer.RecordDlg.Label.IsAVariant"));
        lexiconPane.add(variantLb, gbc);
        gbc.gridx=3;
        // UTD 10/09/12 changed JComboBox to JSuggestComboBox
        lexemeCbBox=new JSuggestComboBox(LexiconDocumentData.getMorphemesToSelect(false).toArray());
        lexemeCbBox.setRenderer(new JDomElementListCellRenderer());
        lexemeCbBox.setSelectedIndex(lexemeSelectedIndex);
        lexiconPane.add(lexemeCbBox, gbc);
        gbc.gridx=4;
        showLexiconButton=new JButton(ElanLocale.getString("LexiconViewer.Button.Show"));
        showLexiconButton.addActionListener(this);
        lexiconPane.add(showLexiconButton, gbc);
	}
	
	 protected void updateLocale() {
		 lexemeLb.setText("Wordform");
		 lexemeTxtField.setText(lexemeText);
	 }
	
	public Element getSelectedLexemeInComboBox(){
		return (Element)lexemeCbBox.getSelectedItem();
	}
	
//	public List<JComboBox> getUFormCbBoxList(){
//	return uFormCbBoxList;
//}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		super.actionPerformed(e);
		if(e.getSource()==showLexiconButton){
			Element elementToShow=(Element)lexemeCbBox.getSelectedItem();
			ShowEditLXDataDialog dialog=new ShowEditLXDataDialog(lxViewer, elementToShow);
			dialog.setVisible(true);
		}
	}
	
}
