package mpi.eudico.client.annotator.lexica.record;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.jdom.Element;

import mpi.eudico.client.annotator.ElanLocale;
import mpi.eudico.client.annotator.viewer.AbstractViewer;

public class LXRecordPanel extends JPanel{
	protected AbstractViewer lxViewer;
	protected JPanel lexiconPane;
	protected JLabel lexemeLb;
	protected JTextField lexemeTxtField;
	protected String lexemeText;
	
	protected List<Element> segmentList;
	protected List<LXSubPanel> parseSegmentPaneList;
	
	/**
	 * Empty constructor
	 */
	public LXRecordPanel(AbstractViewer viewer){
		lxViewer=viewer;
		initComponents();
	}
	
	/**
	 * Construct a new Object with the lexeme value
	 * @param lexemeTxt
	 */
	public LXRecordPanel(AbstractViewer viewer, String lexemeTxt){
		lxViewer=viewer;
		this.lexemeText=lexemeTxt;
		initComponents();
	}
	
	protected void initComponents(){
		lexiconPane=new JPanel();
		lexemeLb=new JLabel();
		lexemeTxtField=new JTextField(10);
		segmentList=new ArrayList<Element>();
		parseSegmentPaneList=new ArrayList<LXSubPanel>();
	}
	
	 protected void updateLocale() {
		 lexemeLb.setText(ElanLocale.getString("LexiconViewer.ConfigurationDlg.Label.Lexeme"));
		 lexemeTxtField.setText(lexemeText);
	 }
	 
	 public JTextField getLexemeTextField(){
		 return lexemeTxtField;
	 }
}
