package mpi.eudico.client.annotator.lexica.record;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;

import org.jdom.Element;

import mpi.eudico.client.annotator.ElanLocale;
import mpi.eudico.client.annotator.lexica.LexiconDocumentData;

public class LXSubPanel extends JPanel{
	protected JLabel morphemeLb;
	protected JTextField morphemeTxtField;
	protected JLabel gloseLb;
	protected JTextField gloseTxtField;
	protected JLabel tamLb;
	protected JTextField tamTxtField;
	protected JLabel tierXLb;
	protected JTextField tierXTxtField;
	protected JButton okButton;
	
	//parseSubPane
	protected JLabel chooseSegmentLb;
	protected JComboBox uFormCbBox;
	protected JButton showMorphemeButton;
	
	protected JTextField segmentTxtField;
	protected JLabel referenceToLb;
	protected JComboBox referenceCbBox;
	protected List<Element> references;
	
	protected Element variantElmt;
	protected JLabel variantLb;
	protected JTextField variantTxtField;
	protected JLabel variantDerLb;
	protected JTextField variantDerTxtField;
	
	public LXSubPanel(Element variantElmt,List<Element> references){
		this.references=references;
		this.variantElmt=variantElmt;
		initComponents();
	}
	
	public LXSubPanel(List<Element> references){
		this.references=references;
		initComponents();
	}
	
	public LXSubPanel(){
		references=new ArrayList<Element>();
		initComponents();
	}
	
	private void initComponents(){
		morphemeLb=new JLabel();
		gloseLb=new JLabel();
		tierXLb=new JLabel();
		tamLb=new JLabel();
		variantDerLb=new JLabel();
		chooseSegmentLb=new JLabel();
		morphemeTxtField=new JTextField(5);
		gloseTxtField=new JTextField(5);
		tamTxtField=new JTextField(5);
		tierXTxtField=new JTextField(5);
		variantDerTxtField=new JTextField(5);
		variantDerTxtField.setEditable(false);
		okButton=new JButton();
		showMorphemeButton=new JButton();
		// UTD : 100912 changed JComboBox to JSuggestComboBox
		uFormCbBox=new JSuggestComboBox(LexiconDocumentData.getMorphemesToSelect(false, false).toArray());
		uFormCbBox.setRenderer(new JDomElementListCellRenderer());
		uFormCbBox.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (SwingUtilities.isRightMouseButton(e) || e.isPopupTrigger()) {
					System.out.println("right click on "+((Element)uFormCbBox.getSelectedItem()).getText());
				}
			}
		});

		showMorphemeButton=new JButton();
		chooseSegmentLb=new JLabel();
		if(references!=null){
			// UTD : 100912 changed JComboBox to JSuggestComboBox
			referenceCbBox=new JSuggestComboBox(references.toArray());
			referenceCbBox.setRenderer(new JDomElementListCellRenderer());
		}
		segmentTxtField=new JTextField(5);
		segmentTxtField.setEditable(false);
		referenceToLb=new JLabel();
		
		variantLb=new JLabel();
		variantTxtField=new JTextField(5);
		
		placeComponents();
		updateLocale();
	}
	
	protected void placeComponents() {
		
	}
	
	protected void updateLocale(){
		morphemeLb.setText(ElanLocale.getString("LexiconViewer.ConfigurationDlg.Label.Morpheme"));
		gloseLb.setText(ElanLocale.getString("LexiconViewer.ConfigurationDlg.Label.Glose"));
		tamLb.setText(ElanLocale.getString("LexiconViewer.ConfigurationDlg.Label.Tam"));
		tierXLb.setText(ElanLocale.getString("LexiconViewer.ConfigurationDlg.Label.TierX"));
		chooseSegmentLb.setText("Segment");
		showMorphemeButton.setText(ElanLocale.getString("VariantPanel.JLabel.Show"));
		okButton.setText("OK");
		referenceToLb.setText("is a reference of :");
		variantLb.setText("Variant");
		variantDerLb.setText(ElanLocale.getString("VariantPanel.JLabel.Slash"));
	}
	
	public JButton getOkButton(){
		return okButton;
	}
	
	public JTextField getMorphemeTxtField(){
		return morphemeTxtField;
	}
	
	public JTextField getGloseTxtField(){
		return gloseTxtField;
	}
	
	public JTextField getTamTxtField(){
		return tamTxtField;
	}
	
	public JTextField getTierXTxtField(){
		return tierXTxtField;
	}
	
	public JButton getShowButton(){
		return showMorphemeButton;
	}
	
	public Element getSelectedUFormElement(){
		return (Element)uFormCbBox.getSelectedItem();
	}
	
	public JTextField getVariantTextField(){
		return variantTxtField;
	}
	
	public List<Element> getReferences(){
		return references;
	}
	
	public JTextField getVariantDerTextField(){
		return variantDerTxtField;
	}
}
