package mpi.eudico.client.annotator.lexica.record;


import java.awt.EventQueue;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Vector;

import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import mpi.eudico.client.annotator.ElanLocale;
import mpi.eudico.client.annotator.lexica.LexiconDocumentData;
import mpi.eudico.client.annotator.viewer.AbstractViewer;

import org.jdom.Element;

public class ShowEditLXRecordPanel extends JPanel {
	protected AbstractViewer lxViewer;
	protected JPanel lexiconPane;
	protected JLabel lexemeLb;
	protected JTextField lexemeTxtField;
	protected String lexemeText;
	protected List<Element> Lexemes;  	// CC 25/05
	protected List<Element> Words;		// CC 25/05
	protected JComboBox lexemeCbBox;
	protected Element selectedElement;
	protected List<Element> lexemeElmtList;
	protected JComboBox wordFormCbBox;
	
	
	public ShowEditLXRecordPanel(AbstractViewer viewer){
		lxViewer=viewer;
		initComponents();
	}
	
	public ShowEditLXRecordPanel(AbstractViewer viewer, Element selectedElement){
		lxViewer=viewer;
		this.selectedElement=selectedElement;
		initComponents();
		//String ok="ok";
	}
	
	@SuppressWarnings("unchecked")
	class ComboKeyHandler extends KeyAdapter{
	    private final JComboBox comboBox;
	    private final Vector<String> list = new Vector<String>();
	    public ComboKeyHandler(JComboBox combo) {
	        this.comboBox = combo;
	        for(int i=0;i<comboBox.getModel().getSize();i++) {
	            list.addElement((String) ((Element)comboBox.getItemAt(i)).getText());
	        }
	    }
	    private boolean shouldHide = false;
	    @Override public void keyTyped(final KeyEvent e) {
	        EventQueue.invokeLater(new Runnable() {
	            @Override public void run() {
	                String text = ((JTextField)e.getSource()).getText();
	                if(text.length()==0) {
	                    setSuggestionModel(comboBox, new DefaultComboBoxModel(list), "");
	                    comboBox.hidePopup();
	                }else{
	                    ComboBoxModel m = getSuggestedModel(list, text);
	                    if(m.getSize()==0 || shouldHide) {
	                        comboBox.hidePopup();
	                    }else{
	                        setSuggestionModel(comboBox, m, text);
	                        comboBox.showPopup();
	                    }
	                }
	            }
	        });
	    }
	    @Override public void keyPressed(KeyEvent e) {
	        JTextField textField = (JTextField)e.getSource();
	        String text = textField.getText();
	        shouldHide = false;
	        switch(e.getKeyCode()) {
	          case KeyEvent.VK_RIGHT:
	            for(String s: list) {
	                if(s.startsWith(text)) {
	                    textField.setText(s);
	                    return;
	                }
	            }
	            break;
	          case KeyEvent.VK_ENTER:
	            if(!list.contains(text)) {
	                list.addElement(text);
	                Collections.sort(list);
	                //setSuggestionModel(comboBox, new DefaultComboBoxModel(list), text);
	                setSuggestionModel(comboBox, getSuggestedModel(list, text), text);
	            }
	            shouldHide = true;
	            break;
	          case KeyEvent.VK_ESCAPE:
	            shouldHide = true;
	            break;
	          default:
	            break;
	        }
	    }
	    private void setSuggestionModel(JComboBox comboBox, ComboBoxModel mdl, String str) {
	        comboBox.setModel(mdl);
	        comboBox.setSelectedIndex(0);
	        ((JTextField)comboBox.getEditor().getEditorComponent()).setText(str);
	    }
	    private ComboBoxModel getSuggestedModel(Vector<String> list, String text) {
	        DefaultComboBoxModel m = new DefaultComboBoxModel();
	        for(String s: list) {
	            if(s.startsWith(text)) m.addElement(s);
	        }
	        return m;
	    }
	} 	
	
	protected void initComponents(){
		lexiconPane=new JPanel();
		lexemeLb=new JLabel();
		lexemeTxtField=new JTextField(10);
		lexemeElmtList=new ArrayList<Element>();
		//lexemes for records
		// UTD : 100912 changed JComboBox to JSuggestComboBox
		lexemeCbBox=new JSuggestComboBox(LexiconDocumentData.getMorphemesToSelect(false).toArray()); 
		lexemeCbBox.setRenderer(new JDomElementListCellRenderer());
		//lexemeCbBox.setEditable(true); 
		// UTD 31/08/12
/*		lexemeCbBox.setSelectedIndex(-1);
		JTextField field = (JTextField)lexemeCbBox.getEditor().getEditorComponent();
		field.setText("");
		field.addKeyListener(new ComboKeyHandler(lexemeCbBox));*/
		
		//CC 2505 to allow jumping to item when typing its beginning 
        /*Lexemes=LexiconDocumentData.getMorphemesToSelect(false);
        List<String> lexList = new ArrayList<String>();
        for ( int l=0; l<Lexemes.size(); l++ ){
			if (Lexemes.get(l)!=null){
				lexList.add(Lexemes.get(l).getText());
			}
		}
		//String[] lexemesList = (String[]) lexList.toArray(new String[0]);
		//lexemeCbBox=new JComboBox(lexemesList);
		lexemeCbBox=new JComboBox(lexList.toArray());
		//lexemeCbBox.setRenderer(new JDomElementListCellRenderer());
		*/
		selectInComboBox(lexemeCbBox, selectedElement);
		
		//wordform for variant elements
		// UTD : 100912 changed JComboBox to JSuggestComboBox
		wordFormCbBox=new JSuggestComboBox(LexiconDocumentData.getMorphemesToSelect(true).toArray());
		wordFormCbBox.setRenderer(new JDomElementListCellRenderer());

		// CC 2505
		/*
		Words=LexiconDocumentData.getMorphemesToSelect(true);
	    List<String> wordList = new ArrayList<String>();
	    for ( int l=1; l<Words.size(); l++ ){
			if (Words.get(l)!=null && Words.get(l).getText()!=""){
				wordList.add(Words.get(l).getText());
			}
		}
		//String[] wordsList = (String[]) wordList.toArray(new String[0]);
	    //wordFormCbBox=new JComboBox(wordsList);  // fin
	    wordFormCbBox=new JComboBox(wordList.toArray());  // fin
		*/
		selectInComboBox(wordFormCbBox, selectedElement);
	}
	
	/**
	 * Init the selected item of the comboBox
	 * @param element
	 */
	protected void selectInComboBox(JComboBox comboBox, Element element){
		if(element!=null){
			for(int i=0; i<comboBox.getItemCount(); i++){
				if(comboBox.getItemAt(i)!=null){
					if(comboBox.getItemAt(i).equals(element)){
						comboBox.setSelectedIndex(i);
						break;
					}
				}
			}
		}
		/*else {
			comboBox.setSelectedIndex(0);
		}*/
	}
	
	protected void updateLocale() {
		 lexemeLb.setText(ElanLocale.getString("LexiconViewer.ConfigurationDlg.Label.Lexeme"));
		 lexemeTxtField.setText(lexemeText);
	}
	
	public Element getSelectedElement(){
		return (Element)lexemeCbBox.getSelectedItem();		
		//return (Element)Lexemes.get(lexemeCbBox.getSelectedIndex());	// CC
	}
	
	public Element getSelectedWordFormElement(){
		return (Element) wordFormCbBox.getSelectedItem();
		//return (Element) Words.get(wordFormCbBox.getSelectedIndex());	// CC
	}
}
