package mpi.eudico.client.annotator.lexica.record;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JPanel;
import javax.swing.SwingUtilities;

import mpi.eudico.client.annotator.lexica.LexiconDocumentData;
import mpi.eudico.client.annotator.viewer.AbstractViewer;

import org.jdom.Element;

public class ShowLXRecordPanel extends ShowEditLXRecordPanel implements ItemListener{
	protected JPanel uFormPane;
	protected JPanel glosePane;
	protected JPanel variantPane;
	protected List<LXSubPanel> gloseTierXPaneList;
	protected List<Element> gloseList;
	protected List<Element> variantList;
	protected List<Element> segmentList;
	
	protected List<LXSubPanel> parseSegmentPaneList;
	protected List<LXSubPanel> variantPaneList;
	
	public ShowLXRecordPanel(AbstractViewer viewer){
		super(viewer);
	}
	
	public ShowLXRecordPanel(AbstractViewer viewer, Element selectedElement){
		super(viewer, selectedElement);
		String tx="ok";
	}
	
	@Override
	protected void initComponents(){
		super.initComponents();
		uFormPane=new JPanel();
		glosePane=new JPanel();
		variantPane=new JPanel();
		lexemeCbBox.addItemListener(this);
		gloseTierXPaneList=new ArrayList<LXSubPanel>();
		gloseList=new ArrayList<Element>();
		variantList=new ArrayList<Element>();
		segmentList=new ArrayList<Element>();
		parseSegmentPaneList=new ArrayList<LXSubPanel>();
		variantPaneList=new ArrayList<LXSubPanel>();
		
		updateLexemePane();
		
    	GridBagLayout gridbag=new GridBagLayout();
    	Insets insets=new Insets(2, 6, 2, 6);
		setLayout(gridbag);
		GridBagConstraints gbc = new GridBagConstraints();
		int y=0;
		gbc.gridx=0;
		gbc.gridy=y;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets=insets;
		gbc.anchor=GridBagConstraints.NORTH;
		add(lexiconPane, gbc);

		y++;
		updateVariantPane();
		gbc.gridx=0;
		gbc.gridy=y;
		add(variantPane, gbc);

		if(this instanceof ShowVariantToRecordPanel){
			updateGlosePane();
		}
		if(glosePane!=null){
			y++;
			gbc.gridx=0;
			gbc.gridy=y;
			add(glosePane, gbc);
		}
		
		if(uFormPane!=null){
			y++;
			gbc.gridx=0;
			gbc.gridy=y;
			add(uFormPane, gbc);
		}
		
		updateLocale();
	}
	
/*	*//**
	 * UTD 05/09/12
	 * Surchage de la méthode updateLexemePane() pour traiter le cas où getSelectecItem renvoie une string et non un élément
	 *
	 *//*
	protected void updateLexemePane(Integer selectedItemIndex) {
		GridBagLayout gridbag=new GridBagLayout();
		lexiconPane.setLayout(gridbag);
		GridBagConstraints gbc=new GridBagConstraints();
		Insets insets=new Insets(2, 6, 2, 6);
		gbc.gridx=0;
		gbc.gridy=0;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.anchor=GridBagConstraints.NORTHEAST;
		gbc.insets=insets;
		lexiconPane.add(lexemeLb, gbc);
		gbc.gridx=0;
		gbc.gridx=1;

		initElementsAssociated(selectedItemIndex);
		if(!((Element)lexemeCbBox.getItemAt(selectedItemIndex)).getAttributeValue(LexiconDocumentData.TYPE).equals(LexiconDocumentData.WF)){
			updateGlosePane();
		} else{
			updateUFormPane();
		}

		lexiconPane.add(lexemeCbBox, gbc);
	}*/

	/**
	 * Lexeme SubPanel
	 */
	protected void updateLexemePane(){
		GridBagLayout gridbag=new GridBagLayout();
		lexiconPane.setLayout(gridbag);
		GridBagConstraints gbc=new GridBagConstraints();
		Insets insets=new Insets(2, 6, 2, 6);
		gbc.gridx=0;
		gbc.gridy=0;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.anchor=GridBagConstraints.NORTHEAST;
		gbc.insets=insets;
		lexiconPane.add(lexemeLb, gbc);
		gbc.gridx=0;
		gbc.gridx=1;
		if(lexemeCbBox.getSelectedItem()!=null){
			/*
			int idx=lexemeCbBox.getSelectedIndex(); 	// CC 080911
			initElementsAssociated((Element)Lexemes.get(idx+1));
			if(!((Element)Lexemes.get(idx+1)).getAttributeValue(LexiconDocumentData.TYPE).equals(LexiconDocumentData.WF)){
			 */
			initElementsAssociated((Element)lexemeCbBox.getSelectedItem());
			if(!((Element)lexemeCbBox.getSelectedItem()).getAttributeValue(LexiconDocumentData.TYPE).equals(LexiconDocumentData.WF)){
				updateGlosePane();
			} else{
				updateUFormPane();
			}
		}
        lexiconPane.add(lexemeCbBox, gbc);
	}
	
	/**
	 * Init all the elements associated to the selected item such as its underlying_form, variants etc.
	 * @param item
	 */
	protected void initElementsAssociated(Element item){
		Element lexicalEntryElmt=item.getParentElement();
		initVariantElements(lexicalEntryElmt);
		initGloseElements(lexicalEntryElmt);
		initSegmentationElements(lexicalEntryElmt);
	}
/*	// UTD 050912
	protected void initElementsAssociated(Integer index){
		Element lexicalEntryElmt = null;
		if (lexemeCbBox.getItemAt(index) instanceof Element) {
			lexicalEntryElmt=((Element) lexemeCbBox.getItemAt(index)).getParentElement();
			initVariantElements(lexicalEntryElmt);
			initGloseElements(lexicalEntryElmt);
			initSegmentationElements(lexicalEntryElmt);
		}else {
			// a faire pour le cas où c'est une string
		}
	}*/
	
	protected void initVariantElements(Element lexicalEntryElmt){
		Element formElmt=lexicalEntryElmt.getChild(LexiconDocumentData.FORM);
		if (formElmt!=null&&formElmt.getChildren(LexiconDocumentData.ALTERNATE_FORM)!=null){
			variantList.addAll(formElmt.getChildren(LexiconDocumentData.ALTERNATE_FORM));
		}
	}
	
	protected void initGloseElements(Element lexicalEntryElmt){
		Element senseElmt=lexicalEntryElmt.getChild(LexiconDocumentData.SENSE);
		if(!senseElmt.getChildren(LexiconDocumentData.GLOSE).isEmpty()){
			gloseList.addAll(senseElmt.getChildren(LexiconDocumentData.GLOSE));
		}
	}
	
	protected void initSegmentationElements(Element lexicalEntryElmt){
		if(lexicalEntryElmt.getChild(LexiconDocumentData.MORPHOLOGY)!=null){
			Element morphElmt=lexicalEntryElmt.getChild(LexiconDocumentData.MORPHOLOGY);
			List<Element> segmentationList=morphElmt.getChildren(LexiconDocumentData.SEGMENT);
			for(Element segmentElmt:segmentationList){
				if(segmentElmt.getAttribute(LexiconDocumentData.REFERENCE)!=null){
					Element segmentX=LexiconDocumentData.getElement(segmentElmt.getAttributeValue(LexiconDocumentData.REFERENCE));
					segmentList.add(segmentX);			
				}
			}
		}
	}
	
	protected void updateGlosePane(){
		GridBagLayout gridbag=new GridBagLayout();
		glosePane.setLayout(gridbag);
		GridBagConstraints gbc=new GridBagConstraints();
		Insets insets=new Insets(2, 6, 2, 6);
		gbc.fill = GridBagConstraints.BOTH;
		gbc.anchor=GridBagConstraints.NORTH;
		gbc.insets=insets;
		gbc.gridx=0;
		gbc.gridy=0;
		if(!gloseList.isEmpty()){
			glosePane.add(addGloseSubPane(gloseList), gbc);
		}
	}
	
	protected void updateVariantPane(){
		Insets insets = new Insets(2, 2, 2, 2);
		GridBagLayout gridbag=new GridBagLayout();
		variantPane.setLayout(gridbag);
		GridBagConstraints gbc=new GridBagConstraints();
    	gbc.insets=insets;
    	gbc.anchor=GridBagConstraints.WEST;
		for(int i=0; i<variantList.size(); i++){
			gbc.gridy=0+i;
	    	gbc.gridx=0;
	    	VariantSubPane variantSubPane;
	    	if(i<variantPaneList.size()){
	    		variantSubPane=(VariantSubPane) variantPaneList.get(i);
	    	} else{
	    		Element altFormElmt=variantList.get(i);
	    		Element morphElmt=altFormElmt.getChild(LexiconDocumentData.MORPHOLOGY);
	    		List<Element> segmentElmtList=null;
	    		if(morphElmt!=null){
	    			segmentElmtList=morphElmt.getChildren(LexiconDocumentData.SEGMENT);
	    		}
	    		variantSubPane=new VariantSubPane(altFormElmt, segmentElmtList);
	    		variantSubPane.setEditable(false);
	    		variantPaneList.add(variantSubPane);
	    	}
	    	variantPane.add(variantSubPane, gbc);
		}
	}
	
	//add glose informations
	protected JPanel addGloseSubPane(List<Element> gloseList){
		JPanel glosePanel=new JPanel();
		GridBagLayout gridbag=new GridBagLayout();
		glosePanel.setLayout(gridbag);
		GridBagConstraints gbc=new GridBagConstraints();
		Insets insets=new Insets(2, 6, 2, 6);
		gbc.fill = GridBagConstraints.BOTH;
		gbc.anchor=GridBagConstraints.EAST;
		gbc.insets=insets;
		gbc.weightx = 1.0;
        gbc.weighty = 1.0;
		for(int i=0; i<gloseList.size(); i++){
			String gloseText=gloseList.get(i).getText();
			String tamText=gloseList.get(i).getAttributeValue(LexiconDocumentData.DERIVATION);
			String tierXText=gloseList.get(i).getAttributeValue(LexiconDocumentData.RX);
			
			gbc.gridx=0;
			gbc.gridy=i;
			GloseTierXSubPane gloseTierXPane;
			if(i<gloseTierXPaneList.size()){
				gloseTierXPane=(GloseTierXSubPane) gloseTierXPaneList.get(i);
			}
			else{
				gloseTierXPane=new GloseTierXSubPane(gloseText, tamText, tierXText);
				gloseTierXPane.setEditable(false);
				gloseTierXPaneList.add(gloseTierXPane);
			}
			glosePanel.add(gloseTierXPane, gbc);
		}
		return glosePanel;
	}

	protected void updateUFormPane(){
		Insets insets = new Insets(2, 2, 2, 2);
		GridBagLayout gridbag=new GridBagLayout();
		uFormPane.setLayout(gridbag);
		GridBagConstraints gbc=new GridBagConstraints();
    	gbc.insets=insets;
    	gbc.anchor=GridBagConstraints.WEST;
		for(int i=0; i<segmentList.size(); i++){
			gbc.gridy=0+i;
	    	gbc.gridx=0;
	    	ParseSegmentsSubPane parsePane;
	    	if(i<parseSegmentPaneList.size()){
	    		parsePane=(ParseSegmentsSubPane) parseSegmentPaneList.get(i);
	    	} else{
	    		parsePane=new ParseSegmentsSubPane(segmentList.get(i));
	    		parsePane.setEditable(false);
	    		parseSegmentPaneList.add(parsePane);
	    	}
	    	uFormPane.add(parsePane, gbc);
		}
	}
	
	@Override
	public void itemStateChanged(ItemEvent e) {
		Object selectedItem=lexemeCbBox.getSelectedItem();
		if(selectedItem instanceof Element){
		//if(selectedItem instanceof String){		// CC 080911
			gloseList.clear();
			variantList.clear();
			segmentList.clear();
			gloseTierXPaneList.clear();
			parseSegmentPaneList.clear();
			variantPaneList.clear();
			variantPane.removeAll();
			glosePane.removeAll();
			uFormPane.removeAll();
			updateLexemePane();
			updateVariantPane();
			getRootPane().repaint();
			SwingUtilities.windowForComponent(this).pack();
		}
	}
}
