package mpi.eudico.client.annotator.lexica.record;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ItemEvent;

import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;

import mpi.eudico.client.annotator.ElanLocale;
import mpi.eudico.client.annotator.lexica.LexiconDocumentData;
import mpi.eudico.client.annotator.viewer.AbstractViewer;

import org.jdom.Element;

/**
 * 
 * @author Coralie
 *
 */
public class ShowVariantToRecordPanel extends ShowLXRecordPanel {
	
	protected JTextField derTxtField;
	
	public ShowVariantToRecordPanel(AbstractViewer viewer){
		super(viewer);
	}
	
	public ShowVariantToRecordPanel(AbstractViewer viewer, Element selectedElement){
		super(viewer, selectedElement);
	}

	@Override
	protected void initComponents(){
		super.initComponents();
		wordFormCbBox.addItemListener(this);
	}
	
	@Override
	protected void updateLocale() {
		 lexemeLb.setText(ElanLocale.getString("VariantPanel.JLabel.WordForm"));
		 lexemeTxtField.setText(lexemeText);
	}
	@Override
	protected void updateLexemePane(){
		GridBagLayout gridbag=new GridBagLayout();
		lexiconPane.setLayout(gridbag);
		GridBagConstraints gbc=new GridBagConstraints();
		Insets insets=new Insets(2, 6, 2, 6);
		gbc.gridx=0;
		gbc.gridy=0;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.anchor=GridBagConstraints.NORTHEAST;
		gbc.insets=insets;
		lexiconPane.add(lexemeLb, gbc);
		gbc.gridx=1;
		lexiconPane.add(wordFormCbBox, gbc);
		if(wordFormCbBox.getSelectedItem()!=null){		
		//if(Words.get(wordFormCbBox.getSelectedIndex())!=null){	// CC 090911
			//Element altFormElmt=((Element)Words.get(wordFormCbBox.getSelectedIndex())).getParentElement();
			Element altFormElmt=((Element)wordFormCbBox.getSelectedItem()).getParentElement();
			if(altFormElmt.getChild(LexiconDocumentData.MORPHOLOGY)!=null){
				initSegmentationElements(altFormElmt);
				updateUFormPane();
			} else{
				uFormPane=null;
			}
		}
        lexiconPane.add(wordFormCbBox, gbc);
	}
	
	@Override
	protected void updateGlosePane(){
		derTxtField=new JTextField();
		GridBagLayout gridbag=new GridBagLayout();
		glosePane.setLayout(gridbag);
		GridBagConstraints gbc=new GridBagConstraints();
		Insets insets=new Insets(2, 6, 2, 6);
		if((Element)wordFormCbBox.getSelectedItem()!=null){ 
		//if(Words.get(wordFormCbBox.getSelectedIndex())!=null){	// CC 090911
			//Element altFormElmt=((Element)(Element)Words.get(wordFormCbBox.getSelectedIndex())).getParentElement();
			Element altFormElmt=((Element)wordFormCbBox.getSelectedItem()).getParentElement();
			Element formElmt=altFormElmt.getParentElement();
			Element lexicalEntry=formElmt.getParentElement();
			Element lexemeElmt=lexicalEntry.getChild(LexiconDocumentData.LEXEME);
			gbc.gridy=0;
			gbc.gridx=0;
			gbc.insets=insets;
			JLabel isAVariantLb=new JLabel(ElanLocale.getString("VariantPanel.JLabel.IsAVariantOf"));
			glosePane.add(isAVariantLb, gbc);
			gbc.gridx=1;
			JTextField mainEntryTxtField=new JTextField(lexemeElmt.getText());
			mainEntryTxtField.setEditable(false);
			glosePane.add(mainEntryTxtField, gbc);
			Element wFormElmt=altFormElmt.getChild(LexiconDocumentData.WRITTENFORM);
			if(wFormElmt.getAttribute(LexiconDocumentData.DERIVATION)!=null){
				gbc.gridy=1;
				gbc.gridx=0;
				JLabel derLabel=new JLabel(ElanLocale.getString("VariantPanel.JLabel.Slash")); 
				glosePane.add(derLabel, gbc);
				gbc.gridx=1;
				derTxtField.setText(wFormElmt.getAttributeValue(LexiconDocumentData.DERIVATION));
				derTxtField.setEditable(false);
				glosePane.add(derTxtField, gbc);
			}
		}
	}
	
	@Override
	public void itemStateChanged(ItemEvent e) {
		Object selectedItem=wordFormCbBox.getSelectedItem();
		if(selectedItem instanceof Element){
			gloseList.clear();
			variantList.clear();
			segmentList.clear();
			gloseTierXPaneList.clear();
			parseSegmentPaneList.clear();
			lexiconPane.removeAll();
			//variantPaneList.clear();
			updateLexemePane();
			
			glosePane.removeAll();
			updateGlosePane();
			if(uFormPane!=null){
				uFormPane.removeAll();
				updateUFormPane();
			}
			getRootPane().repaint();
			SwingUtilities.windowForComponent(this).pack();
		}
	}
	
}
