package mpi.eudico.client.annotator.lexica.record;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.util.List;

import javax.swing.JTextField;

import mpi.eudico.client.annotator.lexica.LexiconDocumentData;

import org.jdom.Element;

public class VariantSubPane extends LXSubPanel{

	private Element writtenFormElmt;
	
	public VariantSubPane(){
		super();
	}
	
	public VariantSubPane(Element variantElmt, List<Element> references){
		super(variantElmt, references);
		//this.setVariantElmt(variantElmt);
		//writtenFormElmt=variantElmt.getChild(LexiconDocumentData.WRITTENFORM);
		variantTxtField.setText(writtenFormElmt.getText());
	}
	
	@Override
	protected void placeComponents(){
		Insets insets = new Insets(2, 2, 2, 2);
		GridBagLayout gridbag=new GridBagLayout();
		setLayout(gridbag);
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.insets=insets;
		gbc.anchor=GridBagConstraints.EAST;
		gbc.gridx=0;
		gbc.gridy=0;
		add(variantLb, gbc);
		gbc.gridx=1;
		add(variantTxtField, gbc);
		writtenFormElmt=variantElmt.getChild(LexiconDocumentData.WRITTENFORM);
		if(writtenFormElmt.getAttribute(LexiconDocumentData.DERIVATION)!=null){
			String derValue=writtenFormElmt.getAttribute(LexiconDocumentData.DERIVATION).getValue();
			variantDerTxtField.setText(derValue);
			gbc.gridx=2;
			add(variantDerLb, gbc);
			gbc.gridx=3;
			add(variantDerTxtField, gbc);
		}
		//segmentList
		if(references!=null){
			for(int i=0; i<references.size(); i++){
				gbc.gridx=i+3;
				JTextField segmentTxtField=new JTextField(references.get(i).getText());
				segmentTxtField.setEditable(false);
				add(segmentTxtField, gbc);
			}
		}
	}
	
	public void setEditable(boolean isEditable){
		variantTxtField.setEditable(isEditable);
	}

	public void setVariantElmt(Element variantElmt) {
		this.variantElmt = variantElmt;
	}

	public Element getVariantElmt() {
		return variantElmt;
	}
}
